import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayDeque;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class accumulator_va {
    public static void main(String[] args) {
        new accumulator_va().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public class Segment implements Comparable<Segment> {
        long minimum, add;
        int id;

        public Segment(long minimum, long add, int id) {
            this.minimum = Math.abs(minimum);
            this.add = add;
            this.id = id;
        }

        public int compareTo(Segment s) {
            return minimum == s.minimum ?
                    Integer.compare(id, s.id) :
                    Long.compare(minimum, s.minimum);
        }

        public String toString() {
            return minimum + " " + add + " " + id;
        }
    }

    public void solve() throws IOException {
        long X = nextInt();
        int k = nextInt();

        ArrayDeque<Long>[] lists = new ArrayDeque[k];
        TreeSet<Segment> segments = new TreeSet<>();
        for (int i = 0; i < lists.length; i++) {
            int l = nextInt();
            lists[i] = new ArrayDeque<>();
            for (int j = 0; j < l; j++) {
                lists[i].add((long) nextInt());
            }
            long min = 0;
            long add = 0;
            while (lists[i].size() > 0 && add <= 0) {
                min = Math.min(add, min);
                add += lists[i].pollFirst();
            }
            if (add > 0) {
                segments.add(new Segment(min, add, i));
            }
        }

        while (segments.size() > 0) {
            Segment p = segments.pollFirst();
            if (p.minimum > X) {
                break;
            }
            X += p.add;
            long min = 0;
            long add = 0;
            while (lists[p.id].size() > 0 && add <= 0) {
                min = Math.min(add, min);
                add += lists[p.id].pollFirst();
            }
            if (add > 0) {
                segments.add(new Segment(min, add, p.id));
            }
        }

        out.println(X);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}