#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <sstream>
#include <list>
#include <queue>
#include <deque>
#include <stack>
#include <cstdlib>
#include <cstdio>
#include <iterator>
#include <functional>
#include <bitset>
#include <random>

#ifdef LOCAL
#define eprintf(...) fprintf(stderr,__VA_ARGS__)
clock_t __my_start_clock = clock();
#else
#define eprintf(...)
#endif

#define TIMESTAMP(x) eprintf("["#x"] Time : %.3lf s.\n", (clock() - __my_start_clock)*1.0/CLOCKS_PER_SEC)
#define TIMESTAMPf(x,...) eprintf("[" x "] Time : %.3lf s.\n", __VA_ARGS__, (clock() - __my_start_clock)*1.0/CLOCKS_PER_SEC)

#define db(x) cerr << #x << " = " << x << endl
#define db2(x, y) cerr << "(" << #x << ", " << #y << ") = (" << x << ", " << y << ")\n";
#define db3(x, y, z) cerr << "(" << #x << ", " << #y << ", " << #z << ") = (" << x << ", " << y << ", " << z << ")\n"
#define dbv(a) cerr << #a << " = "; for (auto xxxx: a) cerr << xxxx << " "; cerr << endl


using namespace std;

#ifdef LOCAL
static struct __timestamper {
    string what;
    __timestamper(const char* what) : what(what){};
    __timestamper(const string& what) : what(what){};
    ~__timestamper(){
        TIMESTAMPf("%s", what.data());
    }
} __TIMESTAMPER("end");
#else
struct __timestamper {};
#endif

typedef long long ll;
typedef long double dbl;


int main() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#endif

    ll s;
    int k;
    while (scanf("%lld%d", &s, &k) == 2) {
        vector<vector<int>> a(k);
        for (auto &v : a) {
            int n;
            scanf("%d", &n);
            v.resize(n);
            for (int &x : v) scanf("%d", &x);
        }

        vector<vector<pair<ll, ll>>> b(k);
        for (int i = 0; i < k; i++) {
            ll mn = 0;
            ll sum = 0;
            for (int x : a[i]) {
                sum += x;
                mn = min(mn, sum);
                if (sum > 0) {
                    b[i].push_back({mn, sum});
                    mn = 0;
                    sum = 0;
                }
            }
            reverse(b[i].begin(), b[i].end());
        }

        priority_queue<pair<ll, int>> q;
        for (int i = 0; i < k; i++) {
            if (!b[i].empty()) {
                q.push({b[i].back().first, i});
            }
        }


        while (!q.empty()) {
            auto top = q.top();
            if (s + top.first < 0) {
                break;
            }
            s += b[top.second].back().second;
            q.pop();
            b[top.second].pop_back();
            if (!b[top.second].empty()) {
                q.push({b[top.second].back().first, top.second});
            }
        }

        printf("%lld\n", s);
    }

    return 0;
}