// Author: Ivan Kazmenko (gassa@mail.ru)
module solution;
import std;

immutable int limit = 10 ^^ 5 + 5;
immutable int mod = 998_244_353;

int powMod (int a, int p)
{
	int res = 1;
	for ( ; p > 0; p >>= 1)
	{
		if (p & 1)
		{
			res = (res * 1L * a) % mod;
		}
		a = (a * 1L * a) % mod;
	}
	return res;
}

int invMod (int a)
{
	return powMod (a, mod - 2);
}

void main ()
{
	auto fact = [1];
	while (fact.length < limit)
	{
		fact ~= (fact.back * 1L * fact.length) % mod;
	}
	auto iFact = fact.map !(invMod).array;

	auto choose (int n, int k)
	{
		int res = fact[n];
		res = (res * 1L * iFact[n - k]) % mod;
		res = (res * 1L * iFact[k]) % mod;
		return res;
	}

	auto tests = readln.strip.to !(int);
	foreach (test; 0..tests)
	{
		int n, k;
		readf !(" %s %s") (n, k);
		long res = 0;
		int n1 = n;

		auto steps = (n1 - 1) / (k * 2);
		n1 -= k * 2 * steps;
		res += k * 2 * (steps * (steps - 1L)) / 2;
		res += steps * n1;

		int num = 0;
		foreach (border; 0..3)
		{
			if (res == 0 && border != 2)
			{
				continue;
			}
			int seats = n1 - border;
			int spaces = k - 1;
			if (seats < 0 || spaces * 2 < seats)
			{
				continue;
			}
			foreach (twos; 0..spaces + 1)
			{
				int remSeats = seats - twos * 2;
				int remSpaces = spaces - twos;
				if (remSeats < 0 || remSpaces < remSeats)
				{
					continue;
				}
				if (res == 0 && remSpaces != remSeats)
				{
					continue;
				}
				num = (num + (1L + (border == 1)) *
				    choose (spaces, twos) *
				    choose (remSpaces, remSeats)) % mod;
			}
		}

		writeln (res, " ", num);
	}
}
