#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <functional>

using namespace std;

const int MOD = 998244353;

const int N = 200005;
int fact[N], ifact[N];

long long binpow(long long a, long long p) {
	return p?binpow(a*a%MOD, p>>1)*(p&1?a:1)%MOD:1;
}
long long bininv(long long a) {
	return binpow(a, MOD-2);
}

long long f(map<int, int> &mp) {
	int c = 0;
	for (auto &kv: mp) {
		c += kv.second;
	}
	int ans = fact[c];
	for (auto &kv: mp) ans = (ans * 1ll * ifact[kv.second]) % MOD;
	if (ans == 0) throw "err";
	return ans % MOD;
}

long long ff(int v) {
	int v1 = (v + 1) / 2;
	if (v%2) {
		return v1 * 1ll * v1 - v;
	}
	return v1 * 1ll * v1 + v1 - v;
}

void solve(int test_ind){
	int n, k;
	cin >> n >> k;
	int cntt = n / k;
	map<long long, int> mp;
	for (int dx=-3;dx<=3;++dx) {
		for (int dy=-3;dy<=3;++dy) {
			int l = cntt/2+dx;
			int r = cntt/2+dy;
			if (l <= 0 || r <= 0 || n - l - r < 0) continue;
			long long inc = l * (l - 1ll) / 2 + r * (r - 1ll) / 2;
			int res = n - l - r;
			if (k > 1) {
				int k1 = k - 1;
				int v = res / k1;
				if (v <= 0) continue;
				int rm = res % k1;
				map<int, int> cnt;
				cnt[v + 1] += rm;
				cnt[v] += k1 - rm;
				inc += cnt[v] * ff(v);
				inc += cnt[v+1] * ff(v+1);
				int odd = v%2?v:v+1;
				mp[inc] += f(cnt);
				mp[inc] %= MOD;
				while (odd > 1 && cnt[odd] > 1) {
					cnt[odd] -= 2;
					cnt[odd-1]++;
					cnt[odd+1]++;
					mp[inc] += f(cnt);
					mp[inc] %= MOD;
				}
			} else if (res == 0) {
				mp[inc] += 1;
				mp[inc] %= MOD;
			}
		}
	}
	if (mp.empty()) throw "Errr";
	cout << mp.begin()->first << " " << mp.begin()->second << endl;
}

int main(){
	fact[0] = 1;
	for (int i=1;i<N;++i) fact[i] = fact[i-1] * 1ll * i % MOD;
	ifact[N-1] = bininv(fact[N-1]);
	for (int i=N-2;i>=0;--i) ifact[i] = ifact[i+1] * (i + 1ll) % MOD;
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	int t=1;
	cin >> t;
	for(int i=0;i<t;i++){
		solve(i);
	}
	return 0;
}
