// Created by Nikolay Budin

#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

const int MOD = 998244353;

void add(int& a, int b) {
	a += b;
	if (a >= MOD) {
		a -= MOD;
	}
}

int sum(int a, int b) {
	add(a, b);
	return a;
}

int mult(int a, int b) {
	return (ll) a * b % MOD;
}

int mpow(int a, int b) {
	int ret = 1;
	while (b) {
		if (b & 1) {
			ret = mult(ret, a);
		}
		a = mult(a, a);
		b /= 2;
	}
	return ret;
}

int inv(int a) {
	return mpow(a, MOD - 2);
}

vector<int> fact, inv_fact;
const int MAXN = 1e6 + 5;

int cnk(int n, int k) {
	return mult(fact[n], mult(inv_fact[k], inv_fact[n - k]));
}

void solve() {
	int n, k;
	cin >> n >> k;
	if (n < 2 + (k - 1) * 2) {
		int left = n - (k + 1);
		cout << 0 << " " << cnk(k - 1, left) << "\n";
		return;
	}
	int l = 0, r = n + 1;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		ll q = mid * 2 + (ll) (k - 1) * mid * 2;
		if (q > n) {
			r = mid;
		} else {
			l = mid;
		}
	}

	ll q = l * 2 + (ll) (k - 1) * l * 2;
	int left = n - q;

	ll inc = (ll) l * (l - 1) / 2 * 2;
	inc += (ll) (k - 1) * l * (l - 1);

	inc += (ll) left * l;

	cout << inc << " ";

	int vars = 0;
	for (pii p : vector<pii>({{0, 1}, {1, 2}, {2, 1}})) {
		if (left < p.ff) {
			continue;
		}
		int cur_left = left - p.ff;
		int cur_vars = 0;
		for (int i = 0; i <= cur_left / 2; ++i) {
			int j = cur_left - i * 2;
			if (i + j <= k - 1) {
				add(cur_vars, mult(cnk(k - 1, i), cnk(k - 1 - i, j)));
			}
		}
		add(vars, mult(cur_vars, p.ss));
	}

	cout << vars << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	fact.push_back(1);
	for (int i = 1; i <= MAXN; ++i) {
		fact.push_back(mult(fact.back(), i));
	}

	inv_fact.push_back(inv(fact.back()));
	for (int i = MAXN; i >= 1; --i) {
		inv_fact.push_back(mult(inv_fact.back(), i));
	}
	reverse(inv_fact.begin(), inv_fact.end());
 
	int test_count = 1;
	cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}