/**
 * code generated by JHelper
 * More info: https://github.com/AlexeyDmitriev/JHelper
 * @author izban
 */

#include <iostream>
#include <fstream>

#include <bits/stdc++.h>

using namespace std;


typedef long long ll;
typedef unsigned long long ull;
typedef double dbl;

#ifdef HOME
#define db(x) { cerr << #x << " = " << x << endl; }
#define db2(x, y) { cerr << "(" << #x << ", " << #y << ") = (" << x << ", " << y << ")" << endl; }
#define db3(x, y, z) { cerr << "(" << #x << ", " << #y << ", " << #z << ") = (" << x << ", " << y << ", " << z << ")" << endl; }
#define dbv(a) { cerr << #a << " = "; for (auto xxx: a) cerr << xxx  << " "; cerr << endl; }
#else
#define db(x) ;
#define db3(x, y, z) ;
#define db2(x, y) ;
#define dbv(a) ;
#endif

#define sz(a)  (int)(a).size()
#define all(a) (a).begin(),a.end()
#define pw(x)  (1LL << (x))


using int_t = int;
using ll_t = long long;

template<typename M>
struct Mint {
#define MOD M::value

    int_t x;

    Mint(const Mint &m) {
        x = m.x;
    }

    Mint() : x(0) {}

    static int_t norm_int(int_t x) {
        if (x < 0 || x >= MOD) {
            x %= MOD;
            if (x < 0) x += MOD;
        }
        return x;
    }

    Mint(int_t _x) {
        x = norm_int(_x);
    }

    template<typename T>
    Mint(T _x) {
        int_t val = ((ll_t) _x % MOD);
        if (val < 0) val += MOD;
        x = static_cast<int_t>(val);
    }

    template<typename U>
    explicit operator U() const {
        return static_cast<U>(x);
    }

    const int_t &operator()() const {
        return x;
    }

    Mint &operator+=(const Mint &b) {
        x += b.x;
        if (x >= MOD) x -= MOD;
        return *this;
    }

    friend Mint operator+(Mint a, const Mint &b) {
        return a += b;
    }

    Mint &operator++() {
        return *this += 1;
    }

    const Mint operator++(int) {
        Mint res = *this;
        *this += 1;
        return res;
    }

    Mint &operator-=(const Mint &b) {
        x -= b.x;
        if (x < 0) x += MOD;
        return *this;
    }

    friend Mint operator-(Mint a, const Mint &b) {
        return a -= b;
    }

    Mint operator-() const {
        return Mint(-x);
    }

    Mint &operator--() {
        return *this -= 1;
    }

    const Mint operator--(int) {
        Mint res = *this;
        *this -= 1;
        return res;
    }

    Mint &operator*=(const Mint &b) {
        x = static_cast<int_t>(static_cast<ll_t>(x) * b.x % MOD);
        return *this;
    }

    friend Mint operator*(Mint a, const Mint &b) {
        return a *= b;
    }

    template<typename T>
    friend Mint bin(Mint a, T n) {
        if (n < 0) {
            return bin(a, -n).inv();
        }
        Mint res(1);
        while (n > 0) {
            if (n & 1) res *= a;
            a *= a;
            n >>= 1;
        }
        return res;
    }

    // prime modulo
    Mint inv() const {
        return bin(*this, MOD - 2);
    }

    Mint &operator/=(const Mint &b) {
        return *this *= b.inv();
    }

    friend Mint operator/(Mint a, const Mint &b) {
        return a /= b;
    }

    bool operator<(const Mint &b) const {
        return x < b.x;
    }

    bool operator>(const Mint &b) const {
        return x > b.x;
    }

    bool operator==(const Mint &b) const {
        return x == b.x;
    }

    bool operator!=(const Mint &b) const {
        return x != b.x;
    }

    friend istream &operator>>(istream &in, Mint &a) {
        int_t t;
        in >> t;
        a.x = norm_int(t);
        return in;
    }

    friend ostream &operator<<(ostream &out, const Mint &a) {
        out << a.x;
        return out;
    }

    friend Mint abs(const Mint &m) {
        return m;
    }

#undef MOD
};

template<typename M>
string to_string(const Mint<M> &a) {
    return to_string(a());
}

struct DynamicMod {
    static int_t value;
};


const int_t MOD = 998244353;
using mint = Mint<std::integral_constant<int_t, MOD>>;
//using mint = Mint<DynamicMod>;







template<typename T>
struct matrix {
    vector<vector<T>> a;

    matrix() {}

    matrix(int n, int m) : a(n, vector<T>(m, T(0))) {}

    matrix(vector<vector<T>> _a) : a(_a) {}

    matrix(const matrix &_a) : a(_a.a) {}

    vector<T> &operator[](int i) {
        assert(0 <= i && i < (int) a.size());
        return a[i];
    }

    const vector<T> &operator[](int i) const {
        assert(0 <= i && i < (int) a.size());
        return a[i];
    }

    matrix operator+(const matrix &b) const {
        assert(a.size() == b.a.size() && a[0].size() == b.a[0].size());
        matrix c = *this;
        for (int i = 0; i < (int) a.size(); i++) {
            for (int j = 0; j < (int) a[0].size(); j++) {
                c[i][j] += b[i][j];
            }
        }
        return c;
    }

    matrix operator-(const matrix &b) const {
        assert(a.size() == b.a.size() && a[0].size() == b.a[0].size());
        matrix c = *this;
        for (int i = 0; i < (int) a.size(); i++) {
            for (int j = 0; j < (int) a[0].size(); j++) {
                c[i][j] -= b[i][j];
            }
        }
        return c;
    }

    matrix operator*(const matrix &b) const {
        assert(a[0].size() == b.a.size());
        matrix c(a.size(), b.a[0].size());
        for (int i = 0; i < (int) a.size(); i++) {
            for (int j = 0; j < (int) b.a[0].size(); j++) {
                T x = 0;
                for (int k = 0; k < (int) a[0].size(); k++) {
                    x += a[i][k] * b[k][j];
                }
                c[i][j] = x;
            }
        }
        return c;
    }

    matrix operator*(T d) const {
        auto b = *this;
        for (auto &v : b.a) {
            for (auto &x : v) {
                x *= d;
            }
        }
        return b;
    }

    bool operator==(const matrix &b) const {
        return a == b.a;
    }

    void print() {
        for (auto v : a) {
            for (auto x : v) cout << x << " ";
            cout << endl;
        }
    }
};

template<>
matrix<mint> matrix<mint>::operator*(const matrix<mint> &b) const {
    assert(a[0].size() == b.a.size());
    matrix c(a.size(), b.a[0].size());
    const ll_t MODMOD = 1LL * MOD * MOD;
    for (int i = 0; i < (int) a.size(); i++) {
        for (int j = 0; j < (int) b.a[0].size(); j++) {
            ll_t x = 0;
            for (int k = 0; k < (int) a[0].size(); k++) {
                x += (ll_t) a[i][k].x * b[k][j].x;
                if (x >= MODMOD) x -= MODMOD;
            }
            c[i][j] = x % MOD;
        }
    }
    return c;
}


template<typename T>
matrix<T> id_matrix(int n) {
    matrix<T> res(n, n);
    for (int i = 0; i < n; i++) {
        res[i][i] = 1;
    }
    return res;
}

template<typename T>
matrix<T> bin(matrix<T> a, long long n) {
    assert(n >= 0);
    matrix<T> res = id_matrix<T>(a.a.size());
    while (n) {
        if (n & 1) res = res * a;
        a = a * a;
        n >>= 1;
    }
    return res;
}


namespace ffti {
    std::vector<mint> root;
    std::vector<int> rev;
    int N;

    void prepRoots() {
        static int lastMod = 0;
        if (MOD == lastMod && (int) root.size() >= N) return;
        lastMod = MOD;

        int cN = max(N, 1 << 17);
        rev.resize(cN);
        root.resize(cN);
        for (int i = 1; i < cN; i++) rev[i] = (rev[i >> 1] >> 1) | ((i & 1) * (cN / 2));
        mint croot = 2;
        while (!(bin(croot, cN) == mint(1) && bin(croot, cN / 2) != mint(1))) croot++;
        mint cur = 1;
        for (int i = cN >> 1; i < cN; i++) {
            root[i] = cur;
            cur *= croot;
        }
        for (int i = (cN >> 1) - 1; i >= 1; i--) {
            root[i] = root[i * 2];
        }
    }

    void prepAB(std::vector<mint> &A, std::vector<mint> &B) {
        N = 1;
        while (N < (int) (A.size() + B.size())) N <<= 1;
        while ((int) A.size() < N) A.push_back(0);
        while ((int) B.size() < N) B.push_back(0);
        prepRoots();
    }

    void fft(std::vector<mint> &f) {
        for (int i = 0; i < N; i++) {
            int j = rev[i] >> __builtin_ctz(root.size() / N);
            if (i < j) std::swap(f[i], f[j]);
        }
        for (int k = 1; k < N; k <<= 1) {
            for (int i = 0; i < N; i += 2 * k) {
                for (int j = 0; j < k; j++) {
                    mint z = f[i + k + j] * root[k + j];
                    f[i + j + k] = f[i + j] - z;
                    f[i + j] = f[i + j] + z;
                }
            }
        }
    }

    std::vector<mint> mul(std::vector<mint> a, std::vector<mint> b) {
        int rsz = a.size() + b.size() - 1;
        if (min(a.size(), b.size()) <= 10) {
//            cout << a.size() << " " << b.size() << endl;
            vector<mint> c(rsz);
            for (int i = 0; i < (int)a.size(); i++) {
                for (int j = 0; j < (int)b.size(); j++) {
                    c[i + j] += a[i] * b[j];
                }
            }
            return c;
        }
        bool eq = a == b;
        prepAB(a, b);

        fft(a);
        if (eq) {
            b = a;
        } else {
            fft(b);
        }
        mint oN = mint(N).inv();
        for (int i = 0; i < N; i++) {
            a[i] = a[i] * b[i] * oN;
        }
        reverse(a.begin() + 1, a.begin() + N);
        fft(a);
        a.resize(rsz);

        return a;
    }
}


#include <math.h>
#include <vector>

namespace fftd {
    struct num {
        double x, y;

        num() {}

        num(double xx, double yy) : x(xx), y(yy) {}

        num(double alp) : x(cos(alp)), y(sin(alp)) {}
    };

    inline num operator+(num a, num b) { return num(a.x + b.x, a.y + b.y); }

    inline num operator-(num a, num b) { return num(a.x - b.x, a.y - b.y); }

    inline num operator*(num a, num b) { return num(a.x * b.x - a.y * b.y, a.x * b.y + a.y * b.x); }

    inline num conj(num a) { return num(a.x, -a.y); }

    const double PI = acos(-1);

    std::vector<num> root;
    std::vector<int> rev;
    std::vector<num> a, b;
    int N;

    void prepRoots() {
        if ((int) root.size() >= N) return;
        int old = root.size();
        root.resize(N);
        if (old == 0) {
            if (root.size() < 2) root.resize(2);
            root[1] = num(1, 0);
        }
        for (int k = 1; (1 << k) < N; k++) {
            if ((1 << k) < old) continue;
            num x(2 * PI / (1LL << (k + 1)));
            for (int i = (1LL << (k - 1)); i < (1LL << (k)); i++) {
                root[2 * i] = root[i];
                root[2 * i + 1] = root[i] * x;
            }
        }
        rev.resize(N);
        for (int i = 1; i < N; i++) rev[i] = (rev[i >> 1] >> 1) | ((i & 1) * (N / 2));
    }

    template<typename T>
    void prepAB(std::vector<T> &A, std::vector<T> &B) {
        N = 1;
        while (N < (int) (A.size() + B.size())) N <<= 1;
        while ((int) A.size() < N) A.push_back(0);
        while ((int) B.size() < N) B.push_back(0);
        prepRoots();
    }

    void fft(std::vector<num> &f) {
        for (int i = 0; i < N; i++) {
            int j = rev[i] >> __builtin_ctz(root.size() / N);
            if (i < j) std::swap(f[i], f[j]);
        }
        for (int k = 1; k < N; k <<= 1) {
            for (int i = 0; i < N; i += 2 * k) {
                for (int j = 0; j < k; j++) {
                    num z = f[i + j + k] * root[j + k];
                    f[i + j + k] = f[i + j] - z;
                    f[i + j] = f[i + j] + z;
                }
            }
        }
    }

    template<typename T>
    std::vector<T> mulMod(std::vector<T> A, std::vector<T> B, int CUR_MOD) {
        int rsz = A.size() + B.size() - 1;
        prepAB(A, B);

        if ((int) a.size() < N) a.resize(N);
        for (int i = 0; i < N; i++) {
            int x = A[i];// % CUR_MOD;
            a[i] = num(x & ((1 << 15) - 1), x >> 15);
        }
        fft(a);
        if (A == B) {
            b = a;
        } else {
            if ((int) b.size() < N) b.resize(N);
            for (int i = 0; i < N; i++) {
                int x = B[i];// % CUR_MOD;
                b[i] = num(x & ((1 << 15) - 1), x >> 15);
            }
            fft(b);
        }
        for (int i = 0; i <= N / 2; i++) {
            int j = (N - i) & (N - 1);
            num a1 = (a[i] + conj(a[j])) * num(0.5, 0);
            num a2 = (a[i] - conj(a[j])) * num(0, -0.5);
            num b1 = (b[i] + conj(b[j])) * num(0.5 / N, 0);
            num b2 = (b[i] - conj(b[j])) * num(0, -0.5 / N);
            if (i != j) {
                num aa1 = (a[j] + conj(a[i])) * num(0.5, 0);
                num aa2 = (a[j] - conj(a[i])) * num(0, -0.5);
                num bb1 = (b[j] + conj(b[i])) * num(0.5 / N, 0);
                num bb2 = (b[j] - conj(b[i])) * num(0, -0.5 / N);
                a[i] = aa1 * bb1 + aa2 * bb2 * num(0, 1);
                b[i] = aa1 * bb2 + aa2 * bb1;
            }
            a[j] = a1 * b1 + a2 * b2 * num(0, 1);
            b[j] = a1 * b2 + a2 * b1;
        }
        fft(a);
        fft(b);
        std::vector<T> C(N);
        for (int i = 0; i < N; i++) {
            long long aa = a[i].x + 0.5;
            long long bb = b[i].x + 0.5;
            long long cc = a[i].y + 0.5;
            C[i] = (aa + bb % CUR_MOD * (1LL << 15) + cc % CUR_MOD * (1LL << 30)) % CUR_MOD;
        }
        C.resize(rsz);
        return C;
    }

    template<typename T>
    std::vector<T> mul(std::vector<T> A, std::vector<T> B) {
        int rsz = A.size() + B.size() - 1;
        prepAB(A, B);

        if ((int) a.size() < N) a.resize(N);
        for (int i = 0; i < N; i++) a[i] = num((double) A[i], (double) B[i]);
        fft(a);
        for (int i = 0; i <= N / 2; i++) {
            int j = (N - i) & (N - 1);
            num x = (a[j] * a[j] - conj(a[i] * a[i])) * num(0, -0.25 / N);
            num y = (a[i] * a[i] - conj(a[j] * a[j])) * num(0, -0.25 / N);
            a[i] = x;
            if (j != i) a[j] = y;
        }
        fft(a);
        std::vector<T> C(N);
        for (int i = 0; i < N; i++) C[i] = (T) round(a[i].x);
        C.resize(rsz);
        return C;
    }
}

#include <cassert>

enum fft_type {
    INT, DOUBLE, DOUBLE_MOD
};

namespace fft {

    fft_type cur_type = INT;
    int cur_mod = MOD;

    void set_type(fft_type new_type) {
        assert(new_type != DOUBLE_MOD);
        cur_type = new_type;
    }

    void set_type(fft_type new_type, int new_mod) {
        assert(new_type == DOUBLE_MOD);
        cur_type = new_type;
        cur_mod = new_mod;
    }

    template<typename T>
    vector<T> mul(const vector<T> &a, const vector<T> &b) {
        if (cur_type == INT) {
            return ffti::mul(a, b);
        } else if (cur_type == DOUBLE) {
            return fftd::mul(a, b);
        } else if (cur_type == DOUBLE_MOD) {
            return fftd::mulMod(a, b, cur_mod);
        } else
            assert(0);
    }
}




// a -- constant array
// a * b = c
// add(k, x):: b[k] = x, returns C[k]

template<typename T>
struct fft_online {
    vector<T> a, b, c;

    fft_online(vector<T> _a) : a(_a) {}

    T add(int k, T x) {
        if ((int) c.size() < 3 * (k + 1)) {
            a.resize(max((int) a.size(), 4 * (k + 1)));
            b.resize(max((int) b.size(), 4 * (k + 1)));
            c.resize(max((int) c.size(), 4 * (k + 1)));
        }
        b[k] = x;
        c[k] += a[0] * b[k];
        int z = 1;
        while ((k & (z - 1)) == (z - 1)) {
            //mult B[k - z + 1 ... k] x A[z .. 2 * z - 1]
            vector<T> ca(z), cb(z);
            for (int i = 0; i < z; i++) ca[i] = a[z + i];
            for (int i = 0; i < z; i++) cb[i] = b[k - z + 1 + i];
            auto cc = fft::mul(ca, cb);
            for (int i = 0; i < 2 * z - 1; i++) c[k + 1 + i] += cc[i];
            z <<= 1;
        }
        return c[k];
    }
};


template<typename T>
struct poly : vector<T> {
    using vector<T>::vector;

    poly(const vector<T> &a) : vector<T>(a) {}

    explicit poly(int x) : vector<T>(x) {}

    friend ostream &operator<<(ostream &out, const poly &p) {
        out << p.to_string();
        return out;
    }

    T &operator[](int id) {
        if (id >= (int) this->size()) this->resize(max(2 * (int) this->size(), id + 1));
        assert(id >= 0 && id < (int) this->size());
        return vector<T>::operator[](id);
    }

    T operator[](int id) const {
        assert(id >= 0);
        if (id < (int) this->size()) return vector<T>::operator[](id);
        return 0;
    }

    poly operator+(const poly &b) {
        const poly &a = *this;
        poly c(max(a.size(), b.size()));
        for (int i = 0; i < (int) c.size(); i++) {
            c[i] = a[i] + b[i];
        }
        return c;
    }

    poly operator+=(const poly &p) {
        return *this = *this + p;
    }

    poly operator-(const poly &b) {
        const poly &a = *this;
        poly c(max(a.size(), b.size()));
        for (int i = 0; i < (int) c.size(); i++) {
            c[i] = a[i] - b[i];
        }
        return c;
    }

    poly operator-=(const poly &p) {
        return *this = *this - p;
    }

    poly operator*(T d) const {
        poly res = *this;
        for (int i = 0; i < (int) this->size(); i++) {
            res[i] *= d;
        }
        return res;
    }

    poly operator*=(T d) {
        return *this = *this * d;
    }

    poly operator/(T d) const {
        poly res = *this;
        T od = T(1) / d;
        for (int i = 0; i < (int) this->size(); i++) {
            res[i] *= od;
        }
        return res;
    }

    poly operator/=(T d) {
        return *this = *this / d;
    }

    poly operator*(const poly &p) const {
        return poly<mint>(fft::mul(*this, p));
    }

    poly operator*=(const poly &p) {
        return *this = *this * p;
    }

    poly inv() const {
        assert((*this)[0] != 0);
        poly r({T(1) / (*this)[0]});
        for (int n = 1; n < (int) this->size(); n <<= 1) {
            poly ca = cut(2 * n);
            r = (r * 2 - r * r * ca).cut(2 * n);
        }
        r.resize(this->size());
        return r;
    }

    poly sqrt() const {
        assert((*this)[0] == 1);
        poly r(1, 1);
        for (int n = 1; n < (int) this->size(); n <<= 1) {
            poly ca = cut(2 * n);
            r = ((r + ca * r.cut(2 * n).inv()) / 2).cut(2 * n);
        }
        r.resize(this->size());
        return r;
    }

    void norm() {
        while (this->size() > 1 && this->back() == 0) {
            this->pop_back();
        }
    }

    poly rev() const {
        return poly(this->rbegin(), this->rend());
    }

    poly cut(int n) const {
        poly res = *this;
        res.resize(n);
        return res;
    }

    pair<poly, poly> div(poly b) const {
        auto a = *this;
        a.norm();
        b.norm();
        if (a.size() < b.size()) return make_pair(poly({0}), a);

        T x = b.back();
        assert(x != 0);
        b /= x;

        auto rb = b.rev().cut(a.size() - b.size() + 1);
        auto q = (rb.inv() * a.rev()).cut(a.size() - b.size() + 1).rev();

        poly r = a - b * q;
        q /= x;
        r.norm();
        return {q, r};
    }

    poly operator/(const poly &p) const {
        return div(p).first;
    }

    poly operator/=(const poly &p) {
        return *this = *this / p;
    }

    poly operator%(const poly &p) const {
        return div(p).second;
    }

    poly operator%=(const poly &p) {
        return *this = *this % p;
    }

    poly derivative() const {
        poly res(max(1, (int) this->size() - 1), 0);
        for (int i = 1; i < (int) this->size(); i++) res[i - 1] = (*this)[i] * i;
        return res;
    }

    poly integrate() const {
        poly res(this->size() + 1);
        for (int i = 1; i < (int) res->size(); i++) {
            res[i] = (*this)[i - 1] / i;
        }
        return res;
    }

    poly exp() const {
        assert((*this)[0] == 0);
        fft_online<T> t(derivative());
        vector<T> g(this->size());
        g[0] = T(1);
        for (int i = 1; i < (int) g.size(); i++) {
            int x = t.add(i - 1, g[i - 1]);
            g[i] = x / T(i);
        }
        return g;
    }

    T eval(T x) const {
        T res = 0;
        for (int i = (int) this->size() - 1; i >= 0; i--) {
            res = res * x + (*this)[i];
        }
        return res;
    }

    string to_string() const {
        string res = "";
        for (int i = 0; i < (int) this->size(); i++) {
            res += ::to_string((*this)[i]);
            if (i + 1 < (int) this->size()) res += " ";
        }
        return res;
    }

    bool operator==(const poly &rgh) const {
        return (vector<T>) *this == (vector<T>) rgh;
    }

    bool operator<(const poly &rgh) const {
        return (vector<T>) *this < (vector<T>) rgh;
    }
};


// given s0, s1, ..., sk-1
//       x0, x1, ..., xk-1
//       sk = x0*sk-1 + ... + xk-1 * s0
// find sn
namespace linear_rec_elem {
    typedef long long ll;

    // O(n^3 log)
    mint find_matrix(ll n, vector<mint> s, vector<mint> x) {
        assert(n >= 0);
        int k = x.size();
        if (n < k) return s[n];
        matrix<mint> a(k, k);
        for (int i = 0; i < k - 1; i++) {
            a[i + 1][i] = 1;
        }
        for (int i = 0; i < k; i++) {
            a[i][k - 1] = x[k - 1 - i];
        }
        a = bin(a, n);
        mint res = 0;
        for (int i = 0; i < k; i++) res += s[i] * a[i][0];
        return res;
    }

    poly<mint> bin(poly<mint> a, ll n, poly<mint> MOD) {
        assert(n > 0);
        poly<mint> res = a;
        n--;
        while (n) {
            if (n & 1) res = res * a % MOD;
            a = a * a % MOD;
            n >>= 1;
        }
        return res;
    }

    // O(n log^2)
    mint find_poly(ll n, vector<mint> s, vector<mint> x) {
        assert(n >= 0);
        int k = x.size();
        if (n < k) return s[n];
        poly<mint> p = poly<mint>(x).rev() * (mint) (MOD - 1);
        p.push_back(1);
        auto t = bin(poly<mint>({0, 1}) % p, n, p).cut(k);
        mint res = 0;
        for (int i = 0; i < k; i++) {
            res += t[i] * s[i];
        }
        return res;
    }
}


poly<mint> bin(poly<mint> a, ll n) {
    assert(n > 0);
    poly<mint> res = a;
    n--;
    while (n) {
        if (n & 1) res = res * a;
        a = a * a;
        n >>= 1;
    }
    return res;
}

pair<ll, ll> solve(ll n, ll k) {
    ll base = n / (2 * k);
    ll rem = n - (2 * base + (k - 1) * 2 * base);

    // divide rem between 1, 2, 2, 2, ..., 1
//        poly p1{vector<mint>{mint(1), mint(1)}};
//        poly p2{vector<mint>{mint(1), mint(1), mint(1)}};
    poly<mint> p1(vector<mint>(2, mint(1)));
    poly<mint> p2(vector<mint>(3, mint(1)));

    if (base == 0) {
        p1[0] = p2[0] = 0;
    }

    poly<mint> p = p1 * p1;
    if (k > 1) p = p * bin(p2, k - 1);

    ll sum = 0;
    // 0 + 1 + ... + base-1
    sum += base * (base - 1) / 2 * (2 * k);
    sum += rem * base;
//        cout << base << " : " << rem << endl;

    return {sum, p[rem].x};
}

void test() {
    for (int it = 0; it < 10; it++) {
        solve(1e9, 1e5);
    }
    cerr << clock() / (double)CLOCKS_PER_SEC << endl;
    exit(0);
}

int main() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#endif
//    test();

    int t;
    scanf("%d", &t);
    while (t--) {
        ll n, k;
        scanf("%lld%lld", &n, &k);
        auto o = solve(n, k);
        printf("%lld %lld\n", o.first, o.second);
    }

    return 0;
}