@file:Suppress("CanBeVal")

import java.io.BufferedReader
import java.io.InputStreamReader
import java.io.OutputStreamWriter
import java.io.PrintWriter
import java.util.*

val MOD = 998244353L

private fun calc_sum(x: Long): Long {
    return if (x % 2 == 0L) {
        (x / 2 - 1) * (x / 2)
    } else {
        (x / 2 - 1) * (x / 2) + x / 2
    }
}

val MAX = 1000000
val fact = LongArray(MAX + 1)
val invFact = LongArray(MAX + 1)

private fun pow(x: Long, y: Long): Long {
    var res = 1L
    var xx = x
    var yy = y
    while (yy > 0) {
        if (yy % 2 == 1L) {
            res = (res * xx) % MOD
        }
        xx = (xx * xx) % MOD
        yy /= 2
    }
    return res
}

private fun inv(x: Long): Long {
    return pow(x, MOD - 2)
}

private fun init() {
    fact[0] = 1L
    invFact[0] = 1L
    for (i in 1..MAX) {
        fact[i] = (fact[i - 1] * i) % MOD
        invFact[i] = (invFact[i - 1] * inv(i.toLong())) % MOD
    }
}

private fun calc_c(a: Int, b: Int, c: Int): Long {
    var res = fact[a + b + c]
    res *= invFact[a]
    res %= MOD
    res *= invFact[b]
    res %= MOD
    res *= invFact[c]
    res %= MOD
    return res
}

private fun calc_cnt(a: Int, b: Int, c: Int, x: Long): Long {
    if (x == 0L && a > 0) {
        return 0L
    }
    var res = 0L
    if (a > 0 && x != 1L) {
        var t = calc_c(a - 1, b, c)
        if (x % 2 == 1L) t *= 2
        res += t
    }
    if (b > 0 && (x + 1) != 1L) {
        var t = calc_c(a, b - 1, c)
        if ((x + 1) % 2 == 1L) t *= 2
        res += t
    }
    if (c > 0 && (x + 2) != 1L) {
        var t = calc_c(a, b, c - 1)
        if ((x + 2) % 2 == 1L) t *= 2
        res += t
    }
    return res
}

private fun solveTest() {
    var n = readInt().toLong()
    var k = readInt()
    var x = n / k
    var y = (n % k).toInt()
    var res_min = calc_sum(x) * (k - y) + calc_sum(x + 1) * y
    var res_cnt = 0L
    if (x % 2 == 0L) {
        var i = 0
        while (2 * i <= y) {
            res_cnt += calc_cnt(k - y + i, y - 2 * i, i, x)
            res_cnt %= MOD
            i++
        }
    } else {
        var i = 0
        while (2 * i <= k - y) {
            res_cnt += calc_cnt(i, k - y - 2 * i, y + i, x - 1)
            res_cnt %= MOD
            i++
        }
    }
    println("$res_min $res_cnt")
}

private fun solve() {
    repeat(readInt()) {
        solveTest()
    }
}

// TEMPLATE
fun main(args: Array<String>) {
    init()
    reader = BufferedReader(InputStreamReader(System.`in`))
    out = PrintWriter(OutputStreamWriter(System.out))
    solve()
    out.close()
}

private lateinit var out: PrintWriter
private lateinit var reader: BufferedReader
private var tokenizer: StringTokenizer? = null
private fun read(): String {
    while (tokenizer == null || !tokenizer!!.hasMoreTokens()) {
        tokenizer = StringTokenizer(readLn())
    }
    return tokenizer!!.nextToken()
}

private fun readInt() = read().toInt()
private fun readLong() = read().toLong()
private fun readLn() = reader.readLine()!!
private fun readInts() = readLn().split(" ").map { it.toInt() }
private fun readInts(sz: Int) = Array(sz) { readInt() }
private fun readLongs() = readLn().split(" ").map { it.toLong() }
private fun readLongs(sz: Int) = Array(sz) { readLong() }
private fun print(b: Boolean) = out.print(b)
private fun print(i: Int) = out.print(i)
private fun print(d: Double) = out.print(d)
private fun print(l: Long) = out.print(l)
private fun print(s: String) = out.print(s)
private fun print(message: Any?) = out.print(message)
private fun print(a: Array<Int>) = a.forEach { print("$it ") }
private fun <T> print(a: Array<out T>) = a.forEach { print("$it ") }
private fun <T> print(a: Collection<T>) = a.forEach { print("$it ") }
private fun println(b: Boolean) = out.println(b)
private fun println(i: Int) = out.println(i)
private fun println(d: Double) = out.println(d)
private fun println(l: Long) = out.println(l)
private fun println(s: String) = out.println(s)
private fun println() = out.println()
private fun println(message: Any?) = out.println(message)
private fun <T> println(a: Array<out T>) {
    a.forEach { print("$it ") }
    println()
}

private fun println(a: IntArray) {
    a.forEach { print("$it ") }
    println()
}

private fun <T> println(a: Collection<T>) {
    a.forEach { print("$it ") }
    println()
}

private fun intarr(sz: Int, v: Int = 0) = IntArray(sz) { v }
private fun longarr(sz: Int, v: Long = 0) = LongArray(sz) { v }
private fun intarr2d(n: Int, m: Int, v: Int = 0) = Array(n) { intarr(m, v) }
private fun <T> init(vararg elements: T) = elements
private fun VI(n: Int = 0, init: Int = 0) = MutableList(n) { init }
private fun VVI(n: Int = 0, m: Int = 0, init: Int = 0) = MutableList(n) { VI(m, init) }
private fun <T1 : Comparable<T1>, T2 : Comparable<T2>> pairCmp(): Comparator<Pair<T1, T2>> {
    return Comparator { a, b ->
        val res = a.first.compareTo(b.first)
        if (res == 0) a.second.compareTo(b.second) else res
    }
}



