#include <bits/stdc++.h>

/**
 * Author: Niyaz Nigmatullin
 *
 */

using namespace std;

int const MOD = 998244353;

long long getCount(int group, bool side) {
	if (side) {
		return (long long) group * (group - 1) / 2;
	}
	return getCount(group / 2, true) + getCount(group - group / 2, true);
}

void solve() {
	int n, k;
	cin >> n >> k;
	long long probablyBestAnswer = (k - n % k) * getCount(n / k, false) + (n % k) * getCount(n / k + 1, false);
	long long bestSum = probablyBestAnswer + 1;
	long long count = 0;
	function<void(int, int, long long)> backtrack = [&](int left, int current, long long sum) {
		if (sum > bestSum) return;
		if (current == k + 1) {
			if (sum < bestSum) {
				bestSum = sum;
				count = 1;
			} else if (sum == bestSum) {
				count++;
			}
			return;
		}
		for (int i = current == k ? max(1, left) : 1; i <= left; i++) {
			backtrack(left - i, current + 1, sum + getCount(i, current == 0 || current == k));
		}
	};
	backtrack(n, 0, 0);
	assert(bestSum < probablyBestAnswer + 1);
	cout << bestSum << ' ' << (count % MOD) << '\n';
}

int main() {
	std::cin.tie(NULL); std::ios::sync_with_stdio(false);
	int t;
	cin >> t;
	while (t--) solve();
}
