

MOD = 998244353
N = 100001

def add(a, b):
	a += b
	if a >= MOD:
		a -= MOD
	return a

def mul(a, b):
	return a * b % MOD

inv = [1] * N
for i in range(2, N):
	inv[i] = mul(inv[MOD % i], MOD - MOD // i)

fact = [1] * N
invfact = [1] * N
for i in range(1, N):
	fact[i] = mul(i, fact[i - 1])
	invfact[i] = mul(inv[i], invfact[i - 1])

def c(n, k):
	return mul(fact[n], mul(invfact[k], invfact[n - k]))

def getWays(borderMin, innerMin, block_size, one_more):
	if borderMin <= 0 or block_size < 0 or one_more < 0 or (block_size & 1) != (one_more & 1):
		return 0
	res = 0
	start = block_size & 1
	if innerMin == 0:
		start = block_size
	for different in range(start, min(block_size, one_more) + 1, 2):
		left1 = block_size - different
		left2 = one_more - different
		left1 >>= 1
		left2 >>= 1
		res = add(res, mul(c(left1 + left2 + different, different), c(left1 + left2, left1)))
	return res

def solve():
	n, k = map(int, input().split())
	block = n // (2 * k)
	one_more = n % (2 * k)
	block_size = 2 * k - one_more
	ans = getWays(block, block, block_size - 2, one_more)
	ways2 = getWays(block, block, block_size - 1, one_more - 1)
	ans = add(ans, ways2)
	ans = add(ans, ways2)
	ans = add(ans, getWays(block + 1, block, block_size, one_more - 2))
	cost = block * (block - 1) // 2 * block_size + block * (block + 1) // 2 * one_more
	print(cost, ans, flush=False)

t = int(input())
for i in range(t):
	solve()
