#include <bits/stdc++.h>

/**
 * Author: Niyaz Nigmatullin
 *
 */

using namespace std;

int const MOD = 998244353;

int add(int a, int b) {
	a += b;
	if (a >= MOD) a -= MOD;
	return a;
}

int mul(int a, int b) {
	return (int) ((long long) a * b % MOD);
}

struct Factorials {
	vector<int> facts;
	vector<int> invFacts;

	Factorials(int n): facts(n), invFacts(n) {
		vector<int> invs(n);
		invs[1] = 1;
		for (int i = 2; i < n; i++) {
			invs[i] = mul(invs[MOD % i], MOD - MOD / i);
		}
		facts[0] = invFacts[0] = 1;
		for (int i = 1; i < n; i++) {
			facts[i] = mul(facts[i - 1], i);
			invFacts[i] = mul(invFacts[i - 1], invs[i]);
		}
	}

	int fact(int n) {
		return facts[n];
	}

	int invfact(int n) {
		return invFacts[n];
	}
};

int const MAXN = 99'999; // 100'000

Factorials fact(MAXN);

int c(int n, int k) {
	return mul(fact.fact(n), mul(fact.invfact(k), fact.invfact(n - k)));
}

int getCount(int side1, int side2, int groupSize, int count1, int count2) {
	if (side1 < 1 || side2 < 1 || count1 < 0 || count2 < 0) {
		return 0;
	}
	int ways = 0;
	for (int both = 0; both <= count1 && both <= count2; both++) {
		int left1 = count1 - both;
		int left2 = count2 - both;
		if (left1 & 1) continue;
		if (left2 & 1) continue;
		if (groupSize == 0 && left1 > 0) continue;
		left1 >>= 1;
		left2 >>= 1;
		ways = add(ways, mul(c(both + left1 + left2, both), c(left1 + left2, left1)));
	}
	return ways;
}

long long getSum(int groupSize) {
	return (long long) groupSize * (groupSize - 1) >> 1;
}

void solveCase() {
	int n, k;
	cin >> n >> k;
	int groupSize = n / (2 * k);
	int countPlusOne = n % (2 * k);
	int countSize = 2 * k - countPlusOne;
	int ways = 0;
	ways = add(ways, getCount(groupSize, groupSize, groupSize, countSize - 2, countPlusOne));
	{
		int toAdd = getCount(groupSize, groupSize + 1, groupSize, countSize - 1, countPlusOne - 1);
		ways = add(ways, toAdd);
		ways = add(ways, toAdd);
	}
	ways = add(ways, getCount(groupSize + 1, groupSize + 1, groupSize, countSize, countPlusOne - 2));
	long long sum = getSum(groupSize) * countSize + getSum(groupSize + 1) * countPlusOne;
	cout << sum << ' ' << ways << '\n';
}

int main() {
	std::cin.tie(NULL); std::ios::sync_with_stdio(false);
	int t;
	cin >> t;
	for (int ct = 0; ct < t; ct++) {
		solveCase();
	}
}
