#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int N = 1005;

set <int> g[N];
set <int> start[N], finish[N];

bool are_cactuses_the_same(int n) {
  for (int i = 1; i <= n; i++) {
    if (g[i] != finish[i]) {
        return false;
    }
  }
  return true;
}

bool used[N];
bool mark[N][N];
int parent[N];

bool dfs(int v, int p) {
  used[v] = true;

  for (auto to: g[v]) {
    if (to == p || mark[v][to]) continue;

    if (used[to]) {
      mark[v][to] = mark[to][v] = true;

      int gag = v;
      while (gag != to) {
        int papa = parent[gag];
        if (mark[papa][gag]) {
          return false;
        }
        mark[papa][gag] = mark[gag][papa] = true;
        gag = papa;
      }
      continue;
    }

    parent[to] = v;
    bool flag = dfs(to, v);
    if (!flag) return false;
  }

  return true;
}

bool is_graph_cactus(int n) {
  bool flag = dfs(1, -1);

  for (int i = 1; i <= n; i++) {
    if (!used[i]) {
      flag = false;
      break;
    }
  }

  // clean
  for (int i = 1; i <= n; i++) {
    used[i] = false;
    for (int j: g[i]) {
      mark[i][j] = false;
    }
  }

  return flag;
}

inline int readAndCheckAnswer(InStream& in, int n) {
  for (int i = 1; i <= n; i++) {
    g[i] = start[i];
  }

  string s = in.readToken("YES|NO", "Existence of solution");

  if (s == "NO") {
    return -1;
  }

  int cnt = in.readInt(0, 15000, "The total number of operations");

  for (int i = 1; i <= cnt; i++) {
    int a = in.readInt(1, n, format("a[%d]", i));
    int b = in.readInt(1, n, format("b[%d]", i));
    int c = in.readInt(1, n, format("c[%d]", i));
    int d = in.readInt(1, n, format("d[%d]", i));

    if (g[a].find(b) == g[a].end()) {
      in.quitf(_wa, "Trying to remove non-existing edge during an operation number %d", i);
    }

    g[a].erase(b);
    g[b].erase(a);

    if (c == d || g[c].find(d) != g[c].end()) {
      in.quitf(_wa, "Trying to add loop or multiedge in graph during an operation number %d", i);
    }

    g[c].insert(d);
    g[d].insert(c);

    if (!is_graph_cactus(n)) {
      in.quitf(_wa, "The graph is already not a cactus after applying an operation number %d", i);
    }
  }

  if (!are_cactuses_the_same(n)) {
    in.quitf(_wa, "The first cactus is not the second one after applying all the operations");
  }

  return 1;
}

int main(int argc, char* argv[]) {
  registerTestlibCmd(argc, argv);

  int n = inf.readInt(3, 1000, "n");
  int m = inf.readInt(n - 1, 3 * (n - 1) / 2, "m");

  for (int i = 0; i < m; i++) {
    int a = inf.readInt(1, n, "a");
    int b = inf.readInt(1, n, "b");
    start[a].insert(b);
    start[b].insert(a);
  }

  for (int i = 0; i < m; i++) {
    int a = inf.readInt(1, n, "a");
    int b = inf.readInt(1, n, "b");
    finish[a].insert(b);
    finish[b].insert(a);
  }

  int jury = readAndCheckAnswer(ans, n);
  int participant = readAndCheckAnswer(ouf, n);

  if (jury != -1 && participant == -1) {
    quitf(_wa, "Jury has the answer but participant has not");
  }
  if (jury == -1 && participant != -1) {
    quitf(_fail, "Participant has the answer but jury has not");
  }

  quitf(_ok, "OK");
  return 0;
}
