#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

const int N = 1005;

vector <int> g[N];

bool used[N];
bool mark[N][N];
int parent[N];

bool dfs(int v, int p) {
  used[v] = true;

  for (auto to: g[v]) {
    if (to == p || mark[v][to]) continue;

    if (used[to]) {
      mark[v][to] = mark[to][v] = true;

      int gag = v;
      while (gag != to) {
        int papa = parent[gag];
        if (mark[papa][gag]) {
          return false;
        }
        mark[papa][gag] = mark[gag][papa] = true;
        gag = papa;
      }
      continue;
    }

    parent[to] = v;
    bool flag = dfs(to, v);
    if (!flag) return false;
  }

  return true;
}

bool is_graph_cactus(int n) {
  bool flag = dfs(1, -1);

  for (int i = 1; i <= n; i++) {
    if (!used[i]) {
      flag = false;
      break;
    }
  }

  // clean
  for (int i = 1; i <= n; i++) {
    used[i] = false;
    for (int j: g[i]) {
      mark[i][j] = false;
    }
  }

  return flag;
}
 
int main(int argc, char *argv[]) {
  registerValidation(argc, argv);

  int n = inf.readInt(3, 1000, "n");
  inf.readSpace();
  int m = inf.readInt(n - 1, 3 * (n - 1) / 2, "m");
  inf.readEoln();

  for (int j = 0; j < 2; j++) {
    map < pair<int, int>, bool > exist;

    for (int i = 1; i <= m; i++) {
      int a = inf.readInt(1, n, format("a[%d]", i));
      inf.readSpace();
      int b = inf.readInt(1, n, format("b[%d]", i));
      inf.readEoln();

      if (a > b) swap(a, b);

      ensuref(a != b, "The given graph (with number %d) should not contain loops", j + 1);
      ensuref(exist.find(make_pair(a, b)) == exist.end(), "The given graph (with number %d) should not contain multiple edges", j + 1);

      exist[make_pair(a, b)] = true;

      g[a].push_back(b);
      g[b].push_back(a);
    }

    ensuref(is_graph_cactus(n), "The given graph (with number %d) should be a cactus", j + 1);

    for (int i = 1; i <= n; i++) {
      g[i].clear();
    }
  }

  inf.readEof();
  return 0;
}
