// Created by Nikolay Budin

#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

vector<pair<pii, pii>> get_seq(int n, vector<pii> edges) {
	int m = szof(edges);
	vector<pair<pii, pii>> ret;
	while (true) {
		// cerr << "edges:\n";
		// for (auto [a, b] : edges) {
		// 	cerr << a << " " << b << endl;
		// }
		vector<vector<int>> graph(n);
		for (auto [a, b] : edges) {
			graph[a].push_back(b);
			graph[b].push_back(a);
		}

		vector<int> used(n);
		vector<vector<int>> cycles;
		vector<int> depth(n);

		vector<int> st;
		function<void(int, int)> dfs = [&](int v, int p) {
			used[v] = 1;
			st.push_back(v);
			for (int to : graph[v]) {
				if (!used[to]) {
					depth[to] = depth[v] + 1;
					dfs(to, v);
				} else if (to != p && used[to] == 1) {
					int q = szof(st) - 1;
					while (st[q] != to) {
						--q;
					}
					cycles.push_back(vector<int>(st.begin() + q, st.end()));
				}
			}

			st.pop_back();
			used[v] = 2;
		};

		dfs(0, 0);

		bool found = false;

		auto do_swap = [&](int a, int b, int c, int d) {
			if (a > b) {
				swap(a, b);
			}
			if (c > d) {
				swap(c, d);
			}
			// cerr << "swap " << a << " " << b << " " << c << " " << d << endl;
			edges.erase(find(edges.begin(), edges.end(), pii(a, b)));
			edges.push_back({c, d});
			ret.push_back({{a, b}, {c, d}});
		};

		for (auto& cycle : cycles) {
			if (szof(cycle) > 3) {
				do_swap(cycle.front(), cycle.back(), cycle.front(), cycle[2]);
				found = true;
				break;
			}
		}

		if (found) {
			continue;
		}

		set<pii> all_edges(edges.begin(), edges.end());
		for (auto& cycle : cycles) {
			// cerr << "cycle" << endl;
			// for (int v : cycle) {
			// 	cerr << v << " ";
			// }
			// cerr << endl;
			for (int i = 0; i < szof(cycle); ++i) {
				int a = cycle[i];
				int b = cycle[(i + 1) % szof(cycle)];
				if (a > b) {
					swap(a, b);
				}
				assert(all_edges.erase({a, b}));
			}
		}

		for (auto [a, b] : all_edges) {
			if (a != 0) {
				int c = 0, d;
				if (depth[a] < depth[b]) {
					d = b;
				} else {
					d = a;
				}
				do_swap(a, b, c, d);
				found = true;
				break;
			}
		}

		if (found) {
			continue;
		}

		vector<bool> trc(n);

		for (auto& cycle : cycles) {
			assert(szof(cycle) == 3);
			for (int i = 0; i < 3; ++i) {
				int v = cycle[i];
				if (all_edges.count({0, v})) {
					int u = cycle[(i + 1) % 3];
					int w = cycle[(i + 2) % 3];
					do_swap(v, u, 0, u);
					do_swap(u, w, u, v);
					found = true;
					break;
				}
			}
			if (found) {
				break;
			}

			if (find(cycle.begin(), cycle.end(), 0) == cycle.end()) {
				for (int v : cycle) {
					trc[v] = true;
				}
			}
		}

		if (found) {
			continue;
		}

		for (auto& cycle : cycles) {
			if (find(cycle.begin(), cycle.end(), 0) != cycle.end()) {
				for (int i = 0; i < 3; ++i) {
					int v = cycle[i];
					if (trc[v]) {
						int u = accumulate(cycle.begin(), cycle.end(), 0) - v;
						int w = all_edges.begin()->ss;
						do_swap(u, v, u, w);
						found = true;
						break;
					}
				}
			}
			if (found) {
				break;
			}
		}

		if (found) {
			continue;
		}

		for (auto& cycle : cycles) {
			sort(cycle.begin(), cycle.end());
		}

		set<vector<int>> set_cycles(cycles.begin(), cycles.end());

		for (int i = 0; i < m - (n - 1); ++i) {
			int a = i * 2 + 1, b = i * 2 + 2;
			vector<int> cur_cycle = {0, a, b};
			if (!set_cycles.count(cur_cycle)) {
				auto it = set_cycles.lower_bound({0, a});
				if (all_edges.count({0, a}) && all_edges.count({0, b})) {
					do_swap((*it)[1], (*it)[2], a, b);
					found = true;
					break;
				}
				if (all_edges.count({0, a})) {
					assert((*it)[1] == b);
					do_swap((*it)[1], (*it)[2], b, a);
					found = true;
					break;
				}
				if (all_edges.count({0, b})) {
					assert((*it)[1] == a);
					do_swap((*it)[1], (*it)[2], a, b);
					found = true;
					break;
				}
				int w = all_edges.begin()->ss;
				assert((*it)[1] == a);
				do_swap((*it)[1], (*it)[2], (*it)[2], w);
				++it;
				assert((*it)[1] == b);
				do_swap((*it)[1], (*it)[2], b, a);
				found = true;
				break;
			}
		}

		if (found) {
			continue;
		}

		break;
	}

	return ret;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<pii> edges1, edges2;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		if (a > b) {
			swap(a, b);
		}
		edges1.push_back({a, b});
	}
	sort(edges1.begin(), edges1.end());
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		if (a > b) {
			swap(a, b);
		}
		edges2.push_back({a, b});
	}
	sort(edges2.begin(), edges2.end());

	if (edges1 == edges2) {
		cout << "YES\n0\n";
		return;
	}

	if (n % 2 == 1 && m == (n - 1) / 2 * 3) {
		cout << "NO\n";
		return;
	}

	auto seq1 = get_seq(n, edges1);
	auto seq2 = get_seq(n, edges2);
	reverse(seq2.begin(), seq2.end());
	for (auto [e1, e2] : seq2) {
		seq1.push_back({e2, e1});
	}

	assert(szof(seq1) <= 15000);

	cout << "YES\n";
	cout << szof(seq1) << "\n";
	for (auto [e1, e2] : seq1) {
		cout << e1.ff + 1 << " " << e1.ss + 1 << " " << e2.ff + 1 << " " << e2.ss + 1 << "\n";
	}
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}