///////////////////////////////    _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <complex>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

const int N = 1005;
const int inf = 1000 * 1000 * 1000;
const int mod = 1000 * 1000 * 1000 + 7;
// mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());
mt19937 myrand(373);

struct Operation {
  int a, b, c, d;
};

int n, m;
set <int> g[2][N];

bool are_cactuses_the_same() {
  for (int i = 1; i <= n; i++) {
    if (g[0][i] != g[1][i]) {
        return false;
    }
  }
  return true;
}

int last_processed = 0;
vector <Operation> answ;

bool mark[2][N][N];
bool used[2][N];
int parent[N];

void dfs1(int x, int v, int p) {
  used[x][v] = true;
  for (auto to: g[x][v]) {
    if (to == p || mark[x][v][to]) continue;

    if (used[x][to]) {
      mark[x][v][to] = mark[x][to][v] = true;
      vector <int> cycle = {to};

      int gag = v;
      while (gag != to) {
        int papa = parent[gag];
        mark[x][papa][gag] = mark[x][gag][papa] = true;
        cycle.push_back(gag);
        gag = papa;
      }

      if ((int)cycle.size() > 3) {
        answ.push_back({cycle[1], cycle[2], cycle[1], cycle.back()});
      }
      continue;
    }

    parent[to] = v;
    dfs1(x, to, v);
  }
}

void dfs2(int x, int v, int p) {
  used[x][v] = true;
  for (auto to: g[x][v]) {
    if (to == p || mark[x][v][to]) continue;

    if (used[x][to]) {
      mark[x][v][to] = mark[x][to][v] = true;

      int gag = v;
      while (gag != to) {
        int papa = parent[gag];
        mark[x][papa][gag] = mark[x][gag][papa] = true;
        gag = papa;
      }
      continue;
    }

    parent[to] = v;
    dfs2(x, to, v);
  }
}

void process(int x) {
  for (int i = last_processed; i < (int)answ.size(); i++) {
    int a = answ[i].a;
    int b = answ[i].b;

    g[x][a].erase(b);
    g[x][b].erase(a);

    int c = answ[i].c;
    int d = answ[i].d;

    g[x][c].insert(d);
    g[x][d].insert(c);
  }
  last_processed = (int)answ.size();
}

void clean(int x) {
  for (int i = 1; i <= n; i++) {
    for (int to: g[x][i]) {
      mark[x][i][to] = false;
    }
    used[x][i] = false;
  }
}

void fixing1(int x, int v) {
  auto it = g[x][v].begin();
  if (*it == 1) {
    ++it;
  }

  int u = *it, w;
  for (int cur_vertex: g[x][v]) {
    if (cur_vertex == 1 || cur_vertex == u) continue;
    if (g[x][u].find(cur_vertex) != g[x][u].end()) {
      w = cur_vertex;
      break;
    }
  }

  answ.push_back({u, w, 1, u});
  answ.push_back({v, w, 1, w});
}

void fixing2(int x, int v) {
  int free_vertex, v2;

  for (auto cur_vertex: g[x][1]) {
    if ((int)g[x][cur_vertex].size() == 1) {
      free_vertex = cur_vertex;
    }
    if (g[x][v].find(cur_vertex) != g[x][v].end()) {
      v2 = cur_vertex;
    }
  }

  auto it = g[x][v].begin();
  while (*it == 1 || *it == v2) {
    ++it;
  }

  int u = *it, w;
  for (int cur_vertex: g[x][v]) {
    if (cur_vertex == 1 || cur_vertex == u || cur_vertex == v2) continue;
    if (g[x][u].find(cur_vertex) != g[x][u].end()) {
      w = cur_vertex;
      break;
    }
  }

  answ.push_back({v, v2, v2, free_vertex});
  answ.push_back({u, w, 1, u});
  answ.push_back({v, w, 1, w});
}

vector <Operation> solve(int x) {
  answ.clear();
  last_processed = 0;

  // make the lengths of all cycles are equal to 3
  dfs1(x, 1, -1);
  clean(x);
  process(x);

  // connect all bridges to the vertex 1
  dfs2(x, 1, -1);

  for (int i = 2; i <= n; i++) {
    for (int to: g[x][i]) {
      if (mark[x][i][to]) continue;
      if (parent[to] == i) {
        answ.push_back({i, to, 1, to});
      }
    }
  }

  clean(x);
  process(x);

  while (true) {
    bool found = false;

    for (auto child: g[x][1]) {
      if ((int)g[x][child].size() % 2 && g[x][child].size() > 1) {
        found = true;
        fixing1(x, child);
        break;
      }
    }

    if (!found) {
      for (auto child: g[x][1]) {
        if ((int)g[x][child].size() % 2 == 0 && g[x][child].size() > 2) {
          found = true;
          fixing2(x, child);
          break;
        }
      }
    }

    if (!found) break;

    process(x);
  }

  // fixing labels
  vector <int> solo;
  for (int i = 2; i <= n; i++) {
    if ((int)g[x][i].size() == 1) {
      solo.push_back(i);
    }
  }

  reverse(solo.begin(), solo.end());

  int total_cycles = m - (n - 1);

  for (int i = 2 * total_cycles + 2; i <= n; i++) {
    if ((int)g[x][i].size() == 2) {
      int v = solo.back();
      auto it = g[x][i].begin();
      ++it;
      int u = *it;

      answ.push_back({i, u, u, v});
      solo.pop_back();

      process(x);
    }
  }

  for (int i = 2; i <= 2 * total_cycles; i += 2) {
    if (g[x][i].find(i + 1) == g[x][i].end()) {
      int v = *g[x][i].rbegin();
      int u = *g[x][i + 1].rbegin();

      answ.push_back({i + 1, u, u, n});
      answ.push_back({i, v, i, i + 1});
      answ.push_back({u, n, u, v});

      process(x);
    }
  }

  return answ;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  cin >> n >> m;

  for (int j = 0; j < 2; j++) {
    for (int i = 1; i <= m; i++) {
      int a, b;
      cin >> a >> b;
      g[j][a].insert(b);
      g[j][b].insert(a);
    }
  }

  if (are_cactuses_the_same()) {
    cout << "YES" << endl;
    cout << 0 << endl;
    return 0;
  }

  if (m % 3 == 0 && n == 2 * m / 3 + 1) {
    cout << "NO" << endl;
    return 0;
  }

  auto prefix = solve(0);
  auto suffix = solve(1);
  reverse(suffix.begin(), suffix.end());

  cout << "YES" << endl;
  cout << (int)prefix.size() + (int)suffix.size() << endl;
  for (auto x: prefix) {
    cout << x.a << " " << x.b << " " << x.c << " " << x.d << endl;
  }
  for (auto x: suffix) {
    cout << x.c << " " << x.d << " " << x.a << " " << x.b << endl;
  }
  return 0;
}
