#include "testlib.h"
#include <iostream>
#include <unordered_set>

using namespace std;

struct Test {
    int b;
    int n;
    bool operator==(const Test &t) const { return t.b == b && t.n == n; }
};

namespace std {
    template <>
    struct hash<Test> {
        auto operator()(const Test &t) const -> size_t {
            return t.b * 31 + t.n;
        }
    };
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int t = atoi(argv[1]);
    int b1 = atoi(argv[2]);
    int b2 = atoi(argv[3]);
    int n1 = atoi(argv[4]);
    int n2 = atoi(argv[5]);
    vector<Test> a;
    unordered_set<Test> s;
    int bs = 0;
    int ns = 0;
    int LIMIT = 1000000;
    while (a.size() < t && bs < LIMIT && ns < LIMIT) {
        int bl = min(b2, LIMIT - bs);
        int nl = min(n2, LIMIT - ns);
        if (bl < b1 || nl < n1) break;
        Test t;
        do {
            t.b = rnd.next(b1, bl);
            t.n = rnd.next(n1, nl);
        } while (!s.insert(t).second);
        a.push_back(t);
        bs += t.b;
        ns += t.n;
    }
    cout << a.size() << endl;
    for (auto t : a) {
        cout << t.b << " " << t.n << endl;
    }
}