#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <algorithm>
#include <sstream>
#include <list>
#include <queue>
#include <deque>
#include <stack>
#include <cstdlib>
#include <cstdio>
#include <iterator>
#include <functional>
#include <bitset>
#include <random>

#ifdef LOCAL
#define eprintf(...) fprintf(stderr,__VA_ARGS__)
clock_t __my_start_clock = clock();
#else
#define eprintf(...)
#endif

#define TIMESTAMP(x) eprintf("["#x"] Time : %.3lf s.\n", (clock() - __my_start_clock)*1.0/CLOCKS_PER_SEC)
#define TIMESTAMPf(x,...) eprintf("[" x "] Time : %.3lf s.\n", __VA_ARGS__, (clock() - __my_start_clock)*1.0/CLOCKS_PER_SEC)

#define db(x) cerr << #x << " = " << x << endl
#define db2(x, y) cerr << "(" << #x << ", " << #y << ") = (" << x << ", " << y << ")\n";
#define db3(x, y, z) cerr << "(" << #x << ", " << #y << ", " << #z << ") = (" << x << ", " << y << ", " << z << ")\n"
#define dbv(a) cerr << #a << " = "; for (auto xxxx: a) cerr << xxxx << " "; cerr << endl


using namespace std;

#ifdef LOCAL
static struct __timestamper {
    string what;
    __timestamper(const char* what) : what(what){};
    __timestamper(const string& what) : what(what){};
    ~__timestamper(){
        TIMESTAMPf("%s", what.data());
    }
} __TIMESTAMPER("end");
#else
struct __timestamper {};
#endif

typedef long long ll;
typedef long double dbl;

pair<int, int> solve(int b, int n) {
    const int INF = 1e9;
    pair<int, int> ans(INF, 0);
    {
        int cur = 1;
        for (int i = 1; i <= 30; i++) {
            cur = 1LL * cur * b % n;
            if (cur == 0) {
                ans = min(ans, {i, 1});
            }
        }
    }
    vector<char> vis(n);
    int cur = 1;
    for (int i = 0;; cur = 1LL * cur * b % n, i++) {
        if (i > 0 && cur == 1) {
            ans = min(ans, {i, 2});
            break;
        }
        if (i > 0 && cur + 1 == n) {
            ans = min(ans, {i, 3});
            break;
        }
        if (vis[cur]) {
            break;
        }
        vis[cur] = 1;
    }
    if (ans.first == INF) ans.first = 0;
    return ans;
}

int main() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#endif

    int T;
    scanf("%d", &T);
    while (T--) {
        int b, n;
        scanf("%d%d", &b, &n);
        auto o = solve(b, n);
        if (o.second == 0) printf("%d\n", 0);
        else printf("%d %d\n", o.second, o.first);
    }

    return 0;
}