#include <bits/stdc++.h>
#define int long long
using namespace std;

//const int P = 37;
//const int MOD = 1e9 + 7;

const int P1 = 37;
const int P2 = 41;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 33;

vector<int> calc_powers(int n, int P, int MOD) {
    vector<int> pows(n);
    pows[0] = 1;
    for (int i = 1; i < n; i++) {
        pows[i] = (pows[i - 1] * P) % MOD;
    }
    return pows;
}

vector<int> calc_hashes(const vector<int> &nums, int P, int MOD) {
    int n = nums.size();
    vector<int> hashes(n + 1);
    for (int i = 0; i < n; i++) {
        hashes[i + 1] = (hashes[i] * P + nums[i]) % MOD;
    }
    return hashes;
}

int calc_hash(int i, int j, const vector<int>& hashes, const vector<int>& pows, int P, int MOD) {
    return (hashes[j] - (hashes[i] * pows[j - i]) % MOD + MOD) % MOD;
}

map<int, int> factor(int n) {
    map<int, int> res;

    for (int i = 2; i * i <= n; ++i) {
        if (n % i == 0) {
            int cnt = 0;
            while (n % i == 0) {
                cnt++;
                n /= i;
            }
            res[i] = cnt;
        }
    }

    if (n > 1)
        res[n] = 1;
    return res;
}

int kind1(int b, int n) {

    auto facn = factor(n);
    auto facb = factor(b);

    int res = -1;
    int fail = 0;

    for (auto [del, pow]: facn) {
        if (facb[del] == 0) {
            fail = 1;
            break;
        }

        res = max(res, (pow + facb[del] - 1) / facb[del]);
    }

    if (fail)
        return 1e9;
    return res;
}

int kind23(int b, int n, int sign=1) {
    vector<int> a, cc;
    int bpowi = 1;
    for (int i = 0; i < n * 2 + 5; ++i) {
        a.push_back(bpowi);
        int c = n - bpowi;
        if (c == n)
            c = 0;
        cc.push_back(c);

        bpowi = (bpowi * b) % n;
    }

    vector<vector<int>> hashes;
    vector<vector<int>> hashes228;
    vector<vector<int>> powss;

    vector<pair<int, int>> hui = {
            {P1, MOD1},
            {P2, MOD2}
    };

    for (auto [P, MOD] : hui) {
        powss.push_back(calc_powers(n * 2 + 5, P, MOD));
        hashes.push_back(calc_hashes(a, P, MOD));
        hashes228.push_back(calc_hashes(cc, P, MOD));
    }

    for (int k = 1; k <= n; k++) {
        bool fail = false;
        for (int i = 0; i < hui.size(); i++) {

            auto &hashe =hashes[i];
            auto &hashe_lol =hashes228[i];
            auto &hpows = powss[i];
            auto [P, MOD] = hui[i];

            int h1 = calc_hash(0, n, hashe, hpows, P, MOD);

            if (sign == 1) {
                int h2 = calc_hash(k, n + k, hashe, hpows, P, MOD);
                if (h1 != h2) {
                    fail = true;
                }
            } else {
                int h2 = calc_hash(k, n + k, hashe_lol, hpows, P, MOD);
                if (h1 != h2) {
                    fail = true;
                }
            }
        }
        if (!fail)
            return k;
    }
    return 1e9;
}


void solve() {
    int b, n;
    cin >> b >> n;

    int kind_ans = -1;
    int k = 1e8;

    int a1 = kind1(b, n);
    if (a1 < k) {
        k = a1;
        kind_ans = 1;
    }

    int a2 = kind23(b, n, 1);
    if (a2 < k) {
        k = a2;
        kind_ans = 2;
    }

    int a3 = kind23(b, n, -1);
    if (a3 < k) {
        k = a3;
        kind_ans = 3;
    }

    if (kind_ans == -1) {
        cout << "0\n";
        return;
    }
    cout << kind_ans << " " << k << "\n";
}

int32_t main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}
