// Author: Ivan Kazmenko (gassa@mail.ru)
module solution;
import std;

immutable int limit = 19;

void main ()
{
	immutable long [] base = limit.iota.map !(i => 10L ^^ i).array;
	immutable long slack = (base[1] + 1) * (base[2] + 1);

	string solve (long v)
	{
		auto w = v - slack;
		string res = "";

		void goSingle (int j, long c)
		{
			auto s = base[j];
			auto j2 = (j - 1) / 2;
			while (c > 0)
			{
				auto k = min (c, 8);
				c -= k;
				res ~= format !("+%s-%s+%s")
				    (s * (k + 1) + 1, s + 1, k);
				w -= (s + 1) * k;
			}
		}

		bool goMulti (int j)
		{
			auto j2 = (j - 1) / 2;
			auto x = base[j - j2] + 1;
			if (w < base[j] + base[j2] + x)
			{
				return false;
			}
			long a = 0, b = 0, c = 0;
			for (int lo = j2, hi = j; lo >= 0; lo--, hi--)
			{
				auto cur = min ((w - x * !!lo) /
				    (base[hi] + base[lo]),
				    8);
				w -= cur * (base[hi] + base[lo]);
				a += base[hi] * (cur + 1) + base[lo];
				b += base[hi] + base[lo];
				c += base[lo] * cur;
			}
			res ~= format !("+%s-%s+%s") (a, b, c);
			return true;
		}

		foreach_reverse (j; 1..limit)
		{
			while (goMulti (j))
			{
			}
			auto c = w / base[j];
			goSingle (j, c);
		}

		w += slack;
		foreach_reverse (i; 0..w / (base[2] + 1) + 1)
		{
			if ((w - i * (base[2] + 1)) % (base[1] + 1) == 0)
			{
				goSingle (2, i);
				goSingle (1, w / (base[1] + 1));
				return res;
			}
		}
		assert (false);
	}

	long p, q;
	while (readf !(" %s %s") (p, q) > 0)
	{
		auto start = "1000000001000000001".to !(long);
//		auto start = '1'.repeat (limit).to !(long);
		debug {write ("print(eval(\"");}
		write (solve (q + start).retro);
		write ("0-", start, "-0");
		write (solve (p + start));
		debug {write ("\"))");}
		writeln;
	}
}
