#include "testlib.h"
 
using namespace std;
 
void dfs(const int v, const vector<vector<int>>& graph, vector<bool>& visited) {
    visited[v] = true;
    for (int to : graph[v])
        if (!visited[to])
            dfs(to, graph, visited);
}
 
int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(2, 100, "n");
    inf.readEoln();
    vector<vector<int>> graph(n);
    for (int i = 0; i < n - 1; ++i) {
        int u = inf.readInt(1, n, format("u[%d]", i + 1));
        inf.readSpace();
        --u;
        int v = inf.readInt(1, n, format("v[%d]", i + 1));
        inf.readEoln();
        --v;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    vector<bool> visited(n);
    const int root = 0;
    dfs(root, graph, visited);
    for (int i = 0; i < n; ++i)
        ensuref(visited[i], "vertex %d is unreachable from %d", i + 1, root + 1);
    int s = inf.readInt(1, n, "s");
    inf.readEoln();
    inf.readEof();
}
