#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
 
void ml() {
    for (long long i = 1; i < 1e18; ++i)
        new long long[i];
}
 
void tl() {
    double d = 0;
    for (long long i = 1; i < 1e18; ++i)
        d += 1. / i;
    std::cout << "TL with side effect " << d << '\n';
}
 
int find_distance_dfs(const int a, const int b, const std::vector<std::vector<int>>& graph, std::vector<bool>& visited) {
    if (a == b)
        return 0;
    visited[a] = true;
    for (int to : graph[a])
        if (!visited[to]) {
            int distance = find_distance_dfs(to, b, graph, visited);
            if (distance >= 0)
                return distance + 1;
        }
    return -1;
}
 
std::pair<double, double> find_ans(const int n, const int k, const int l) {
    if (k == 0 || l == 0)
        tl();
    long double A = n - k - l + 1, B = n - k - l + 1;
    for (int i = 0; i < 15000; ++i) {
        long double AA = (n - k - l + 1) + (1 - (1 - 2 * (k - 1) / A) / l) * B;
        long double BB = (n - k - l + 1) + (1 - (1 - 2 * (l - 1) / B) / k) * A;
        A = AA;
        B = BB;
    }
    return {A, B};
}
 
int find_distance(const int a, const int b, const std::vector<std::vector<int>>& graph) {
    const int n = graph.size();
    std::vector<bool> visited(n);
    return find_distance_dfs(a, b, graph, visited);
}
 
int main() {
    int n;
    std::cin >> n;
    std::vector<std::vector<int>> graph(n);
    std::vector<std::pair<int, int>> leaf_degrees(n);
    for (int i = 0; i < n; ++i)
        leaf_degrees[i].second = i;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u;
        --v;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    for (int i = 0; i < n; ++i)
        for (int j : graph[i])
            if (graph[j].size() == 1)
                ++leaf_degrees[i].first;
    std::sort(leaf_degrees.rbegin(), leaf_degrees.rend());
    int L = leaf_degrees[0].second, R = leaf_degrees[1].second;
    int k = 0, l = 0, m = 0;
    for (int i = 0; i < n; ++i)
        if (i == L || i == R)
            ++m;
        else if (graph[i].size() == 1 && graph[i][0] == L)
            ++k;
        else if (graph[i].size() == 1 && graph[i][0] == R)
            ++l;
        else if (graph[i].size() == 2)
            ++m;
    if (k + l + m < n)
        ml();
    std::cout << std::fixed << std::setprecision(30);
    if (k == 0) {
        std::cout << 1. << '\n';
        return 0;
    }
    if (l == 0) {
        int s;
        std::cin >> s;
        --s;
        if (graph[s].size() == 1)
            std::cout << double(2 * n - 4) << '\n';
        else
            std::cout << 2 * n - 5 + 2. / (n - 1) << '\n';
        return 0;
    }
    std::pair<double, double> AB = find_ans(n, k, l);
    const double A = AB.first, B = AB.second;
    int s;
    std::cin >> s;
    --s;
    if (s == L || s == R || graph[s].size() == 2) {
        int y = find_distance(L, s, graph);
        std::cout << (A * B * (k + l - 1) - A * (k * l + l * l - l * n + l * y) + B * (k * y + k)) / (A * l + B * k) << '\n';
    } else if (graph[s][0] == L)
        std::cout << A << '\n';
    else
        std::cout << B << '\n';
}
