#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
 
void ml() {
    for (long long i = 1; i < 1e18; ++i)
        new long long[i];
}
 
int find_distance_dfs(const int a, const int b, const std::vector<std::vector<int>>& graph, std::vector<bool>& visited) {
    if (a == b)
        return 0;
    visited[a] = true;
    for (int to : graph[a])
        if (!visited[to]) {
            int distance = find_distance_dfs(to, b, graph, visited);
            if (distance >= 0)
                return distance + 1;
        }
    return -1;
}
 
std::pair<double, double> find_ans(const int n, const int k, const int l) {
    if (k != l || k == 0)
        ml();
    const double A = n * k - 2 * k * k + 3 * k - 2;
    return {A, A};
}
 
int find_distance(const int a, const int b, const std::vector<std::vector<int>>& graph) {
    const int n = graph.size();
    std::vector<bool> visited(n);
    return find_distance_dfs(a, b, graph, visited);
}
 
int main() {
    int n;
    std::cin >> n;
    std::vector<std::vector<int>> graph(n);
    std::vector<std::pair<int, int>> degrees(n);
    for (int i = 0; i < n; ++i)
        degrees[i].second = i;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        std::cin >> u >> v;
        --u;
        --v;
        graph[u].push_back(v);
        graph[v].push_back(u);
        ++degrees[u].first;
        ++degrees[v].first;
    }
    std::sort(degrees.rbegin(), degrees.rend());
    int L = degrees[0].second, R = degrees[1].second;
    int k = 0, l = 0, m = 0;
    for (int i = 0; i < n; ++i)
        if (i == L || i == R)
            ++m;
        else if (graph[i].size() == 1 && graph[i][0] == L)
            ++k;
        else if (graph[i].size() == 1 && graph[i][0] == R)
            ++l;
        else if (graph[i].size() == 2)
            ++m;
    if (k + l + m < n)
        ml();
    std::pair<double, double> AB = find_ans(n, k, l);
    const double A = AB.first, B = AB.second;
    int s;
    std::cin >> s;
    --s;
    std::cout << std::fixed << std::setprecision(30);
    if (s == L || s == R || graph[s].size() == 2) {
        int y = find_distance(L, s, graph);
        std::cout << (A * B * (k + l - 1) - A * (k * l + l * l - l * n + l * y) + B * (k * y + k)) / (A * l + B * k) << '\n';
    } else if (graph[s][0] == L)
        std::cout << A << '\n';
    else
        std::cout << B << '\n';
}
