// Created by Nikolay Budin

#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif
#define int long long

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n, q;
	cin >> n >> q;
	vector<int> arr;
	ll tot_sum = 0;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		arr.push_back(num);
		tot_sum += num;
	}

	int chunk_size = max((int) 1, (int) sqrt(n));
	int chunks_number = (n + chunk_size - 1) / chunk_size;
	vector<pii> chunk_max(chunks_number);
	vector<vector<pii>> chunk_records_lr(chunks_number);
	vector<vector<pii>> chunk_records_rl(chunks_number);
	vector<ll> records_sum_lr(n), records_sum_rl(n);
	vector<int> chunk_add(chunks_number);
	
	auto rebuild_chunk = [&](int ind) {
		int l = ind * chunk_size;
		int r = min((ind + 1) * chunk_size, n);
		chunk_max[ind] = {-INF, -1};
		chunk_records_lr[ind].clear();
		chunk_records_rl[ind].clear();
		int maxv = -INF;
		ll sum = 0;
		for (int i = l; i < r; ++i) {
			arr[i] += chunk_add[ind];
			if (arr[i] > maxv) {
				maxv = arr[i];
				chunk_max[ind] = {arr[i], i};
				chunk_records_lr[ind].push_back({arr[i], i});
			}
			records_sum_lr[i] = sum;
			sum += maxv;
		}

		chunk_add[ind] = 0;

		maxv = -INF;
		sum = 0;
		for (int i = r - 1; i >= l; --i) {
			if (arr[i] > maxv) {
				maxv = arr[i];
				chunk_records_rl[ind].push_back({arr[i], i});
			}
			records_sum_rl[i] = sum;
			sum += maxv;
		}
	};

	for (int i = 0; i < chunks_number; ++i) {
		rebuild_chunk(i);
	}

	vector<pii> before_after(chunks_number);

	for (int req_ind = -1; req_ind < q; ++req_ind) {
		if (req_ind >= 0) {
			int l, r;
			cin >> l >> r;
			--l;
			tot_sum += r - l;

			if (l / chunk_size == (r - 1) / chunk_size) {
				for (int j = l; j < r; ++j) {
					arr[j]++;
				}
				rebuild_chunk(l / chunk_size);
			} else {
				int l2 = (l + chunk_size - 1) / chunk_size * chunk_size;
				int r2 = r / chunk_size * chunk_size;
				
				if (l < l2) {
					for (int j = l; j < l2; ++j) {
						arr[j]++;
					}
					rebuild_chunk(l / chunk_size);
				}
				if (r2 < r) {
					for (int j = r2; j < r; ++j) {
						arr[j]++;
					}
					rebuild_chunk(r2 / chunk_size);
				}

				for (int j = l2 / chunk_size; j < r2 / chunk_size; ++j) {
					chunk_add[j]++;
				}
			}
		}

		int maxv = 0;
		for (int i = 0; i < chunks_number; ++i) {
			before_after[i].ff = maxv;
			maxv = max(maxv, chunk_max[i].ff + chunk_add[i]);
		}

		maxv = 0;
		for (int i = chunks_number - 1; i >= 0; --i) {
			before_after[i].ss = maxv;
			maxv = max(maxv, chunk_max[i].ff + chunk_add[i]);
		}

		ll tot_water = 0;

		for (int i = 0; i < chunks_number; ++i) {
			int l = i * chunk_size;
			int r = min((i + 1) * chunk_size, n);
			int maxh = chunk_max[i].ff + chunk_add[i];
			if (min(before_after[i].ff, before_after[i].ss) >= maxh) {
				tot_water += (ll) (r - l) * min(before_after[i].ff, before_after[i].ss);
				continue;
			}

			int mid = chunk_max[i].ss;
			tot_water += maxh;
			if (before_after[i].ff >= maxh) {
				tot_water += (mid - l) * maxh;
			} else {
				auto it = lower_bound(chunk_records_lr[i].begin(), chunk_records_lr[i].end(), 
					pii(before_after[i].ff - chunk_add[i], -1));
				int pos = it->ss;
				tot_water += records_sum_lr[mid] - records_sum_lr[pos] + chunk_add[i] * (mid - pos);
				tot_water += (ll) before_after[i].ff * (pos - l);
			}

			if (before_after[i].ss >= maxh) {
				tot_water += (r - mid - 1) * maxh;
			} else {
				auto it = lower_bound(chunk_records_rl[i].begin(), chunk_records_rl[i].end(), 
					pii(before_after[i].ss - chunk_add[i], -1));
				int pos = it->ss;
				tot_water += records_sum_rl[mid] - records_sum_rl[pos] + chunk_add[i] * (pos - mid);
				tot_water += (ll) before_after[i].ss * (r - pos - 1);
			}
		}

		cout << tot_water - tot_sum << "\n";
	}
}


int32_t main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}