///////////////////////////////    _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <cassert>
#include <complex>
#include <chrono>
#include <random>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

const int N = 200005;
const int inf = 1000 * 1000 * 1000;
const int mod = 998244353;
// mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());
mt19937 myrand(373);

int n, q;
long long sum = 0;

struct SegmentTree {
  int d[4 * N];
  int mx[4 * N];
  long long answ = 0;

  void init(int n, vector <int> &a) {
    build(1, 1, n, a);

    int pref_max = 0;
    for (int i = 1; i <= n; i++) {
      if (a[i] == mx[1]) break;
      pref_max = max(pref_max, a[i]);
      answ += pref_max;
    }
  }

  void build(int v, int s, int e, vector <int> &a) {
    d[v] = 0;
    if (s == e) {
      mx[v] = a[s];
      return;
    }
    int m = (s + e) / 2;
    build(2 * v, s, m, a);
    build(2 * v + 1, m + 1, e, a);
    mx[v] = max(mx[2 * v], mx[2 * v + 1]);
  }

  void push(int v, int s, int e) {
    if (d[v] == 0) return;

    mx[v] += d[v];

    if (s != e) {
      d[2 * v] += d[v];
      d[2 * v + 1] += d[v];
    }
    d[v] = 0;
  }

  void update(int v, int s, int e, int l, int r) {
    push(v, s, e);
    if (l > r) return;
    if (s == l && e == r) {
      d[v]++;
      push(v, s, e);
      return;
    }
    int m = (s + e) / 2;
    update(2 * v, s, m, l, min(r, m));
    update(2 * v + 1, m + 1, e, max(m + 1, l), r);
    mx[v] = max(mx[2 * v], mx[2 * v + 1]);
  }

  int get_max(int v, int s, int e, int l, int r) {
    push(v, s, e);
    if (l > r) return 0;
    if (s == l && e == r) return mx[v];
    int m = (s + e) / 2;
    return max(get_max(2 * v, s, m, l, min(r, m)), get_max(2 * v + 1, m + 1, e, max(m + 1, l), r));
  }

  // first index where a[ind] >= val
  int get_ind(int v, int s, int e, int val) {
    push(v, s, e);
    if (s == e) {
      if (mx[v] >= val) return s;
      return inf;
    }
    int m = (s + e) / 2;

    push(2 * v, s, m);
    push(2 * v + 1, m + 1, e);

    if (mx[2 * v] >= val) {
      return get_ind(2 * v, s, m, val);
    }
    return get_ind(2 * v + 1, m + 1, e, val);
  }

  void update(int n, int l, int r) {
    int mx_pref2 = get_max(1, 1, n, 1, r);
    int pos = get_ind(1, 1, n, mx_pref2 + 1);

    int old_max_pos = get_ind(1, 1, n, mx[1]);

    update(1, 1, n, l, r);

    int new_max_pos = get_ind(1, 1, n, mx[1]);

    if (new_max_pos < old_max_pos) {
      answ -= (mx[1] - 1) * 1ll * (old_max_pos - new_max_pos);
    } else {
      answ += (mx[1] - 1) * 1ll * (new_max_pos - old_max_pos);
    }

    int mx_pref = get_max(1, 1, n, 1, l - 1);
    int new_nxt = get_ind(1, 1, n, mx_pref + 1);

    if (new_nxt > r) return;

    mx_pref2 = get_max(1, 1, n, 1, r);
    int lst_pos = get_ind(1, 1, n, mx_pref2);

    answ += lst_pos - new_nxt;
    if (pos <= n && new_max_pos > r) {
      answ += pos - lst_pos;
    }
  }
};

SegmentTree A, B;

long long get_answer() {
  long long pat = A.answ + B.answ;
  int L = A.get_ind(1, 1, n, A.mx[1]);
  int R = n - B.get_ind(1, 1, n, B.mx[1]) + 1;
  pat += (R - L + 1) * 1ll * A.mx[1];
  return pat;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  cin >> n >> q;

  vector <int> a(n + 1);
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
    sum += a[i];
  }

  A.init(n, a);
  reverse(a.begin() + 1, a.end());
  B.init(n, a);

  cout << get_answer() - sum << endl;
  while (q--) {
    int l, r;
    cin >> l >> r;
    sum += r - l + 1;
    A.update(n, l, r);
    B.update(n, n - r + 1, n - l + 1);
    cout << get_answer() - sum << endl;
  }
  return 0;
}
