// Alice [cdkrot.me] Sayutina (2023)

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;
using std::queue;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int64_t solve(const vector<int>& arr) {
    auto n = ssize(arr);
    vector<int> lmax(n), rmax(n);

    lmax[0] = arr[0];
    for (int i = 1; i < n; ++i)
        lmax[i] = max(lmax[i-1], arr[i]);

    rmax.back() = arr.back();
    for (int i = n-2; i >= 0; --i)
        rmax[i] = max(rmax[i+1], arr[i]);

    int64_t ans = 0;
    for (int i = 0; i < n; ++i)
        ans += min(lmax[i], rmax[i]) - arr[i];

    return ans;
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    int n, q;
    cin >> n >> q;

    vector<int> arr(n);
    input_seq(ALL(arr));

    cout << solve(arr) << "\n";

    for (int t = 0; t < q; ++t) {
        int l, r;
        cin >> l >> r;
        --l, --r;

        for (int i = l; i <= r; ++i)
            ++arr[i];

        cout << solve(arr) << "\n";
    }

    return 0;
}
