#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

struct solver {
    vector<vector<int>> g;
    vector<vector<int>> g2;

    vector<int> z;
    vector<int> p;

    bool dfs(int x, int ex) {
        z[x] = 1;
        if (x != ex) {
            for (int y: g[x]) {
                if (z[y] == 1) return false;
                if (z[y] == 0) {
                    if (!dfs(y, ex)) {
                        return false;
                    }
                }
            }
        }
        z[x] = 2;
        if (x != ex) p.push_back(x);
        return true;
    }

    bool is_acyclic(vector<int> c, int ex) {
        for (int x: c) z[x] = 0;
        p.clear();
        for (int x: c) {
            if (z[x] == 0) {
                if (!dfs(x, ex)) return false;
            }
        }
        return true;
    }

    vector<bool> z2;
    vector<int> p2;

    void dfs2(int x) {
        if (z2[x]) return;
        z2[x] = true;
        for (int y: g2[x]) {
            dfs2(y);
        }
        p2.push_back(x);
    }

    bool is_solvable(int n, vector<pair<int, int>> e) {
        g.resize(n);
        g2.resize(n);
        for (auto [a, b] : e) {
            a--;
            b--;
            g[b].push_back(a);
            g2[a].push_back(b);
            g2[b].push_back(a);
        }
        z.resize(n);
        z2.resize(n);
        for (int i = 0; i < n; i++) {
            if (z2[i]) continue;
            p2.clear();
            dfs2(i);
            if (is_acyclic(p2, -1)) {
            } else {
                bool ok = false;
                for (int ex: p2) {
                    if (is_acyclic(p2, ex)) {
                        p.push_back(ex);
                        ok = true;
                        break;
                    }
                }
                if (!ok) {
                    return false;
                }
            }
        }
        return true;
    }
};

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> e(m);
    for (int i = 0; i < m; i++) {
        cin >> e[i].first >> e[i].second;
    }
    while (solver().is_solvable(n, e)) {
        int i = rnd.next(0, m - 1);
        int x = rnd.next(1, n);
        int y = rnd.next(1, n);
        if (x != y) {
            e[i] = {x, y};
        }
    }
    
    cout << n << " " << m << "\n";
    for (auto [x, y] : e) {
        cout << x << " " << y << "\n";
    }
    return 0;
}