#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define TIME (clock() * 1.0 / CLOCKS_PER_SEC)

const int M = 1010;

vector<int> go[M];
vector<int> both[M];
int n, m;

bool used[M];

vector<pair<int, int>> ans;
vector<int> comp;

int indeg[M];

void dfs(int p) {
    comp.emplace_back(p);
    used[p] = true;
    for (int i : both[p]) {
        if (!used[i]) {
            dfs(i);
        }
    }
}

int topsort[M], cnt_topsort;
int tuse[M], cnt_use;
int active[M], cnt_active;

bool dfs_tp(int p) {
    active[p] = cnt_active;
    tuse[p] = cnt_use;
    for (int i : go[p]) {
        if (tuse[i] != cnt_use) {
            if (!dfs_tp(i)) {
                return false;
            }
        } else {
            if (active[i] == cnt_active) {
                return false;
            }
        }
    }
    topsort[cnt_topsort++] = p;
    active[p] = cnt_active - 1;
    return true;
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int s, f;
        cin >> s >> f;
        s--, f--;
        go[s].emplace_back(f);
        both[s].emplace_back(f);
        both[f].emplace_back(s);
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            comp.clear();
            dfs(i);
            for (int x : comp) {
                for (int y : go[x]) {
                    indeg[y]++;
                }
            }
            {
                cnt_active++;
                cnt_use++;
                cnt_topsort = 0;
                bool ok = true;
                for (int x : comp) {
                    if (indeg[x] == 0) {
                        ok |= dfs_tp(x);
                        if (!ok) {
                            break;
                        }
                    }
                }
                if (ok && cnt_topsort == comp.size()) {
                    reverse(topsort, topsort + cnt_topsort);
                    for (int q = 0; q + 1 < cnt_topsort; q++) {
                        ans.emplace_back(topsort[q], topsort[q + 1]);
                    }
                    continue;
                }
            }
            bool found = false;
            for (int ban : comp) {
                for (int y : go[ban]) {
                    indeg[y]--;
                }
                cnt_active++;
                cnt_use++;
                tuse[ban] = cnt_use;
                cnt_topsort = 0;
                bool ok = true;
                for (int x : comp) {
                    if (x != ban && indeg[x] == 0) {
                        ok |= dfs_tp(x);
                        if (!ok) {
                            break;
                        }
                    }
                }
                if (ok && cnt_topsort == (int)comp.size() - 1) {
                    reverse(topsort, topsort + cnt_topsort);
                    topsort[cnt_topsort++] = ban;
                    ans.emplace_back(ban, topsort[0]);
                    for (int q = 0; q + 1 < cnt_topsort; q++) {
                        ans.emplace_back(topsort[q], topsort[q + 1]);
                    }
                    found = true;
                    break;
                }
                for (int y : go[ban]) {
                    indeg[y]++;
                }
            }
            if (!found) {
                cout << "-1\n";
                return;
            }
        }
    }
    cout << ans.size() << "\n";
    for (const auto& t : ans) {
        cout << t.first + 1 << " " << t.second + 1 << "\n";
    }
}

int main() {
#ifdef ONPC
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
