#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef __float128 ld;
 
const ld pi = acosl((ld)-1.0);
 
// _________ vect (2D) ______________
template <typename T>
struct vect {
    T x = 0;
    T y = 0;
 
    vect() = default;
    vect(T x_, T y_) : x(x_), y(y_) {}
    int half() const { return y < (T)0; }
};
 
template <typename T>
inline istream& operator>>(istream& in, vect<T>& v) {
    return in >> v.x >> v.y;
}
 
template <typename T>
inline ostream& operator<<(ostream& out, vect<T>& v) {
    return out << "[" << v.x << "," << v.y << "]";
}
 
template <typename T>
inline vect<T> operator-(const vect<T>& a, const vect<T>& b) {
    return vect<T>(a.x - b.x, a.y - b.y);
}
 
template <typename T>
inline T operator^(const vect<T>& a, const vect<T>& b) {
    return a.x * b.y - a.y * b.x;
}
 
bool operator<(const vect<ld>& a, const vect<ld>& b) {
    int ha = a.half();
    int hb = b.half();
    if (ha != hb) {
        return ha < hb;
    }
    if (ha == 0) {
        return a.x > b.x;
    } else {
        return a.x < b.x;
    }
}
 
ld divide(__int128 a, ll b) {
    return (ld)(a / b) + ((ld)(a % b) / (ld)b);
}
 
vect<ld> get_angle(const vect<ll>& a, const vect<ll>& b, const vect<ll>& c, ll triangle_area) {
    auto side1 = b - a;
    auto side2 = c - a;
    ll tot_area = abs(side1 ^ side2);
 
    __int128 vx = (__int128)side1.x * (tot_area - triangle_area) + (__int128)side2.x * triangle_area;
    __int128 vy = (__int128)side1.y * (tot_area - triangle_area) + (__int128)side2.y * triangle_area;
 
    vect<ld> v(divide(vx, tot_area), divide(vy, tot_area));
    ld r = hypotl(v.x, v.y);
    v.x /= r; v.y /= r;
 
    return v;
}
 
void solve() {
    int n;
    ll s;
    cin >> n >> s;
    s *= 2;
    vector<vect<ll>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    vector<pair<vect<ld>, pair<ld, ld>>> events;
    for (int it = 0; it < 2; it++) {
        int p = 0;
        ll ps = 0;
 
        int k = 0;
        ll sx = 0;
        ll sy = 0;
 
        auto upd = [&](int i, int cf) {
            k += cf;
            sx += v[i].x * cf;
            sy += v[i].y * cf;
        };
        upd(0, 1);
 
        for (int i = 0; i < n; i++) {
            if (it == 0) {
                upd(i, -1);
            }
 
            while (abs(ps + (v[p] ^ v[(p + 1) % n]) + (v[(p + 1) % n] ^ v[i])) <= s - it) {
                ps += (v[p] ^ v[(p + 1) % n]);
                p = (p + 1) % n;
                upd(p, 1);
            }
 
            ll triangle_area = s - abs(ps + (v[p] ^ v[i]));
            auto angle = get_angle(v[i], v[p], v[(p + 1) % n], triangle_area);
            if (it == 1) {
                angle.x *= -1; angle.y *= -1;
            }
 
            ld c_sin = -divide(sx, k);
            ld c_cos = divide(sy, k);
 
            events.emplace_back(angle, make_pair(c_sin, c_cos));
 
            ps -= (v[i] ^ v[(i + 1) % n]);
 
            if (it == 1) {
                upd(i, -1);
            }
        }
        reverse(v.begin(), v.end());
    }
 
    sort(events.begin(), events.end());
 
    vector<ld> positive;
    vector<ld> negative;
 
    auto add = [&](ld x) {
        if (x < 0) {
            negative.emplace_back(-x);
        } else {
            positive.emplace_back(x);
        }
    };
 
    for (int i = 0; i < (int)events.size(); i++) {
        auto phi = events[(i + 1) % (int)events.size()].first;
        add(-events[i].second.first * phi.x);
        add(events[(i + 1) % (int)events.size()].second.first * phi.x);
        add(events[i].second.second * phi.y);
        add(-events[(i + 1) % (int)events.size()].second.second * phi.y);
    }
    for (int i = 0; i < n; i++) {
        auto vc = v[(i + 1) % n] - v[i];
        add(hypotl(vc.x, vc.y));
    }
 
    sort(positive.begin(), positive.end());
    ld pos = 0;
    for (ld x : positive) {
        pos += x;
    }
    sort(negative.begin(), negative.end());
    ld neg = 0;
    for (ld x : negative) {
        neg += x;
    }
 
    ld ans = (pos - neg);
 
    ans /= 2 * pi;
 
    cout << (long double)ans << "\n";
}
 
int main()
{
#ifdef ONPC
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
 
    cout << fixed << setprecision(20);
 
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
 
    return 0;
}
