#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <functional>

using namespace std;


int precalc_data[17][17][3];

int gcd(int a, int b) {
    return a == 0 ? b : gcd(b % a, a);
}

void gcd(int a, int b, int& x, int& y) {
    if (a == 0) {
        x = 0; y = 1;
    } else {
        gcd(b % a, a, x, y);

        // (b - b / a * a) * x + a * y = 1
        // a * (y - b / a * x) + b * x = 1
        
        y -= b / a * x;
        swap(x, y);
    }
}

void precalc() {
    for (int a = 1; a <= 16; a++) {
        for (int b = 1; b <= 16; b++) {
            int x, y;
            int d = gcd(a, b);
            gcd(a / d, b / d, x, y);
            
            precalc_data[a][b][0] = d;
            precalc_data[a][b][1] = x;
            precalc_data[a][b][2] = y;
        }
    }
}

pair<long long, long long> get_xy(int a, int b, int n) {
    int d = precalc_data[a][b][0];
    
    if (n % d != 0) {
        return make_pair(-1, -1);
    }

    long long x = precalc_data[a][b][1] * 1ll * n / d;
    long long y = precalc_data[a][b][2] * 1ll * n / d;

    int x_step = b / d;
    int y_step = a / d;

    if (x < 0) {
        long long cnt = (-x - 1) / x_step + 1;
        x += cnt * x_step;
        y -= cnt * y_step;
        return make_pair(x, y);
    } else {
        long long cnt = x / x_step;
        x -= cnt * x_step;
        y += cnt * y_step;
        return make_pair(x, y);
    }
} 


void solve(int test_ind){
	int n;
	cin >> n;
	int k;
	cin >> k;
	vector<int> v(k);
	for (int &i: v) cin >> i;
	if (k == 1) {
		if (n % v[0]) {
			cout << 0 << endl;
		} else {
			cout << 1 << endl;
		}
		return;
	}
	if (k == 2) {
		auto pr = get_xy(v[0], v[1], n);
		if (pr.second < 0) cout << 0 << endl;
		else cout << pr.second / (v[0] / __gcd(v[0], v[1])) + 1 << endl;
		return;
	}
	long long ans = 0;
	for (int i=0;i<v[0] * v[1];++i) {
		auto pr = get_xy(v[0], v[1], n - v[2] * i);
		if (pr.second < 0) continue;
		long long Y = pr.second / (v[0] / __gcd(v[0], v[1])) + 1;
		long long d = v[2] * __gcd(v[0], v[1]);
		long long fi = Y % d, la = Y;
		long long cnt = (la - fi) / d + 1;
		ans += cnt * (fi + la) / 2;
	}
	cout << ans << endl;
}

int main(){
	precalc();
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	int t=1;
	cin >> t;
	for(int i=0;i<t;i++){
		solve(i);
	}
	return 0;
}
