// Some stupid optimizations

#include <cassert>
#include <iostream>
#include <vector>

using namespace std;
using LL = long long;

LL GCD(LL a, LL b) {
    while (b > 0) {
        a %= b;
        swap(a, b);
    }
    return a;
}

// LL LCM(LL a, LL b) {
//     return a * b / GCD(a, b);
// }

LL solve_1(int T, int A) {
    if (T % A != 0)
        return 0;
    return 1;
}

// the smallest x: (T - A * x) % B == 0
// assume gcd(A, B) = 1
int find_x0(int T, int A, int B) {
    // int x0 = -1;
    for (int x = 0; x < B; x++) {
        if ((T - A * x) % B == 0) {
            return x;
            // assert(x0 == -1);
            // x0 = x;
        }
    }
    assert(0);
    // assert(x0 != -1);
    // return x0;
}

// Ax + By = T - how much solutions (x, y)
// g is GCD(A, B)
LL solve_2(int T, int A, int B, int g) {
    if (T % g != 0)
        return 0;

    A /= g;
    B /= g;
    T /= g;

    const int x0 = find_x0(T, A, B);
    const int y0 = find_x0(T, B, A);

    if (A * x0 + B * y0 > T)
        return 0;

    const int xmax = (T - B * y0) / A;
    // assert(x0 <= xmax);
    // assert((xmax - x0) % B == 0);

    return (xmax - x0) / B + 1;
}

// sum [i = 0 .. count-1] (a0 + delta * i)
LL arithm_sum(LL a0, LL delta, LL count) {
    return count * a0
        + count * (count - 1) / 2 * delta;
}

LL solve_3(int T, int A, int B, int C) {
    const int g = GCD(A, B);
    const int L = A * B / g;

    LL answer = 0;

    for (int z0 = 0; z0 < L; z0++) {
        if (C * z0 > T)
            continue;

        // z(k) = z0 + k * L
        // T(k) = T - C * z(k)

        const int zmax = ((T / C) - z0) / L * L + z0;
        // assert(zmax >= z0);
        // assert((zmax - z0) % L == 0);
        const int count = (zmax - z0) / L + 1;

        const int z1 = z0 + L;
        const LL s0 = solve_2(T - C * z0, A, B, g);
        const LL s1 = solve_2(T - C * z1, A, B, g);
        const LL delta = s1 - s0;

        answer += arithm_sum(s0, delta, count);
    }

    return answer;
}

int main() {
    std::ios::sync_with_stdio(false);
    cin.tie(0);

    int tests;
    cin >> tests;
    for (int i = 0; i < tests; i++) {
        int T, cnt;
        cin >> T >> cnt;
    
        vector<int> nums(cnt);
        for (int& x : nums) cin >> x;

        LL answer =
            cnt == 1
                ? solve_1(T, nums[0])
            : cnt == 2
                ? solve_2(T, nums[0], nums[1], GCD(nums[0], nums[1]))
                : solve_3(T, nums[0], nums[1], nums[2]);

        cout << answer << '\n';
    }
}
