// Author: Ivan Kazmenko (gassa@mail.ru)
module solution;
import std;

int solve2 (int n, int x, int y)
{
	auto v = new bool [y];
	for (int i = 0, nc = n; i < y && nc >= 0; i++, nc -= x)
	{
		v[i] = !(nc % y);
	}
	auto full = n / (x * y);
	auto res = full * sum (v);
	n -= full * (x * y);
	return res + sum (v[0..n / x + 1]);
}

long solve3 (int n, int x, int y, int z)
{
	auto v = new long [y * z * 2];
	for (int i = 0, nc = n; i < y * z * 2 && nc >= 0; i++, nc -= x)
	{
		v[i] = solve2 (nc, y, z);
	}
	long res = 0;
	for (int i = 0; i < y * z; i++)
	{
		auto one = v[i];
		if (one == 0)
		{
			continue;
		}
		auto two = v[i + y * z];
		auto delta = one - two;
		enforce (delta > 0);
		auto steps = one / delta;
		res += (steps + 1L) * (one + one - delta * steps) / 2;
	}
	return res;
}

long solve (int n, int k, int [] a)
{
	if (k == 1)
	{
		return n % a[0] == 0;
	}
	if (k == 2)
	{
		return solve2 (n, a[0], a[1]);
	}
	return solve3 (n, a[0], a[1], a[2]);
}

void main ()
{
	auto tests = readln.strip.to !(int);
	foreach (test; 0..tests)
	{
		auto a = readln.splitter.map !(to !(int)).array;
		auto n = a[0];
		auto k = a[1];
		a = a[2..$];
		writeln (solve (n, k, a));
	}
}
