#pragma GCC optimize("O3")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include <iostream>
#include <fstream>

#include <bits/stdc++.h>

using namespace std;


typedef long long ll;
typedef unsigned long long ull;
typedef double dbl;

#ifdef HOME
#define db(x) { cerr << #x << " = " << x << endl; }
#define db2(x, y) { cerr << "(" << #x << ", " << #y << ") = (" << x << ", " << y << ")" << endl; }
#define db3(x, y, z) { cerr << "(" << #x << ", " << #y << ", " << #z << ") = (" << x << ", " << y << ", " << z << ")" << endl; }
#define dbv(a) { cerr << #a << " = "; for (auto xxx: a) cerr << xxx  << " "; cerr << endl; }
#else
#define db(x) ;
#define db3(x, y, z) ;
#define db2(x, y) ;
#define dbv(a) ;
#endif

#define sz(a)  (int)(a).size()
#define all(a) (a).begin(),a.end()
#define pw(x)  (1LL << (x))



vector<ll> mul(vector<ll> a, vector<ll> b) {
    vector<ll> c(a.size() + b.size() - 1);
    for (int i = 0 ;i < a.size(); i++) {
        for (int j = 0; j < b.size(); j++) {
            c[i + j] += a[i] * b[j];
        }
    }
    return c;
}

ll find(ll n, vector<ll> p, vector<ll> q) {
    if (n == 0) {
        assert(q[0] == 1);
        return p[0];
    }

    vector<ll> nq = q;
    for (int i = 1; i < (int)nq.size(); i += 2) nq[i] *= -1;
//
//    auto s = mul(p, nq);
//    vector<ll> s0, s1;
//    for (int i = 0; i < (int)s.size(); i++) {
//        if (i % 2 == 0) s0.push_back(s[i]);
//        else s1.push_back(s[i]);
//    }
//    auto tt = mul(q, nq);
//    vector<ll> t;
//    for (int i = 0; i < (int)tt.size(); i++) {
//        if (i % 2 == 0) t.push_back(tt[i]);
//        else assert(tt[i] == 0);
//    }
//    assert(t.size() == q.size());

    vector<ll> s(q.size());
    vector<ll> t(q.size());

    for (int i = 0; i < (int)q.size(); i++) {
        int si = n % 2 + 2 * i;

        // 0 <= si-j < p.size()
        // -si <= -j < -si + p.size()
        // si >= j > si - p.size()
        int minj = max(0, si - (int)p.size() + 1);
        int maxj = min((int)q.size()-1, si);
        for (int j = minj; j <= maxj; j++) {
            int l = si - j;
            s[i] += p[l] * nq[j];
        }
    }
    for (int i = 0; i < (int)q.size(); i++) {
        int ti = 2 * i;
        int minj = max(0, ti - (int)p.size() + 1);
        int maxj = min((int)q.size()-1, ti);
        for (int j = minj; j <= maxj; j++) {
            int l = ti - j;
            t[i] += q[l] * nq[j];
        }
    }

    return find(n / 2, s, t);
}

ll solve(int n, vector<int> a) {
    vector<ll> q(1, 1);
    for (int x : a) {
        vector<ll> c(x + 1);
        c[0] = 1;
        c[x] = -1;
        q = mul(q, c);
    }

    auto p = vector<ll>(q.size(), 0);
    p[0] = 1;
    return find(n, p, q);
}

void test() {
    for (int i = 0; i < 16384; i++) {
        int n = 1e9;
        vector<int> a{16,15,14};
        solve(n, a);
    }
    cerr << clock() / (double)CLOCKS_PER_SEC << endl;
    exit(0);
}

int main() {
#ifdef LOCAL
    freopen("in", "r", stdin);
#endif
//    test();

    int T;
    scanf("%d", &T);
    while (T--) {
        int n;
        int k;
        scanf("%d%d", &n, &k);
        vector<int> a(k);
        for (int i = 0; i < k; i++) scanf("%d", &a[i]);

        printf("%lld\n", solve(n, a));
    }

    return 0;
}