// (C) Alice Sayutina 2023
// 16^2 log(16) per test.

// say no to homophobia, transphobia and racism.

import java.io.PrintWriter
import java.util.*

object SolutionPokemons {
    fun euclid(a: Int, b: Int): Pair<Int, Int> {
        if (b == 0)
            return Pair(1, 0)

        val k = a / b
        val res = euclid(b, a - k * b)
        // b * res.first + (a-kb)*res.second = g
        return Pair(res.second, res.first - k * res.second)
    }

    fun solve1(a: Int, t: Int): Long {
        if (t % a != 0)
            return 0
        return 1
    }

    fun solve2(a: Int, b: Int, t: Int): Long {
        val xy = euclid(a, b)
        val g = xy.first * a + xy.second * b

        if (t < 0 || t % g != 0)
            return 0

        val a = a / g
        val b = b / g
        val t = t / g

        val sol = Pair(xy.first.toLong() * t, xy.second.toLong() * t)
        // sol.first + lambda*b >= 0
        // sol.second - lambda*a >= 0
        // (-sol.first) / b <= lambda <= sol.second / a

        val R = Math.floorDiv(sol.second, a.toLong())
        val L = Math.floorDiv(-sol.first + b - 1, b.toLong())
        return Math.max(0, R - L + 1)
    }

    fun solve3(a: Int, b: Int, c: Int, t: Int): Long {
        var ans: Long = 0

        for (i in 0..<a * b) {
            val tprime = t - i * c
            val tprimeprime = t - (i + a * b) * c

            val f1 = solve2(a, b, tprime)
            val f2 = solve2(a, b, tprimeprime)

            if (f2 == 0L) {
                ans += f1
            } else {
                val f3 = solve2(a, b, t - (i + 2 * a * b) * c)

                val delta = f1 - f2

                val cnt = 1 + f1 / delta

                ans += cnt * (f1 + f1 - delta * (cnt - 1)) / 2
            }
        }
        return ans
    }
}


fun main(args: Array<String>) {
    val sc = Scanner(System.`in`.buffered())
    val writer = PrintWriter(System.out.buffered())

    val tc = sc.nextInt()

    for (i in 1..tc) {
        val t = sc.nextInt()
        val len = sc.nextInt()
        val arr = IntArray(len) { sc.nextInt() }

        val ans = when (len) {
            1 -> SolutionPokemons.solve1(arr[0], t)
            2 -> SolutionPokemons.solve2(arr[0], arr[1], t)
            3 -> SolutionPokemons.solve3(arr[0], arr[1], arr[2], t)
            else -> -1
        }

        writer.println(ans)
    }
    writer.flush()
}
