#include <cstdint>
#include <iostream>

int64_t SolveSingleTest() {
  int64_t total_limbs;
  int64_t num_gen;
  std::cin >> total_limbs >> num_gen;
  if (num_gen == 1) {
    int64_t a;
    std::cin >> a;
    int64_t result = 0;
    if (total_limbs % a == 0) {
      ++result;
    }
    return result;
  }
  if (num_gen == 2) {
    int64_t a, b;
    std::cin >> a >> b;
    int64_t result = 0;
    for (int64_t i = 0; i < b; ++i) {
      for (int64_t j = 0; j < a; ++j) {
        int64_t left = total_limbs - a * i - b * j;
        if (left < 0 || left % (a * b) != 0) {
          continue;
        }
        left /= a * b;
        result += left + 1;
      }
    }
    return result;
  }
  if (num_gen == 3) {
    int64_t a, b, c;
    std::cin >> a >> b >> c;
    int64_t result = 0;
    for (int64_t i = 0; i < b * c; ++i) {
      for (int64_t j = 0; j < a * c; ++j) {
        for (int64_t k = 0; k < a * b; ++k) {
          int64_t left = total_limbs - a * i - b * j - c * k;
          if (left < 0 || left % (a * b * c) != 0) {
            continue;
          }
          left = left / (a * b * c);
          result += (left + 1) * (left + 2) / 2;
        }
      }
    }
    return result;
  }
  std::cout << "ERROR\n";
  return -17;
}

int main(int argc, char** argv) {
  int t;
  std::cin >> t;
  for (int i = 0; i < t; i++) {
    std::cout << SolveSingleTest() << "\n";
  }
  return 0;
}