#include <iostream>
#include <vector>

using namespace std;

int main() {
    std::ios::sync_with_stdio(false);

    int n;
    cin >> n;

    vector<int> a(n);
    for (int& x : a) {
        cin >> x;
    }

    vector<vector<vector<int>>> dp(n + 1, vector(2, vector(2, 0)));

    const int MOD = 998244353;
    const auto& add = [](int& x, int y) {
        x += y;
        if (x >= MOD) {
            x -= MOD;
        }
    };

    vector<int> seen(2);
    for (int len = 1; len <= n; len++) {
        dp[len] = dp[len - 1];

        int x = a[len - 1] % 2;
        for (int y = 0; y < 2; y++) {
            int& value = dp[len][x][y];

            add(value, seen[y]);

            for (int z = 0; z < 2; z++) {
                if (x + y + z == 0) {
                    continue;
                }
                if ((x + y + z) % 2 == 0) {
                    add(value, dp[len - 1][y][z]);
                }
            }
        }
        seen[x]++;
    }

    // cerr << "! " << dp[2][0][1] << endl;

    int answer = 1;

    for (int i = 0; i < seen[0]; i++) {
        add(answer, answer);
    }
    add(answer, MOD - 1); // - of len 0
    if (seen[0] >= 1) {
        add(answer, MOD - seen[0]); // - of len 1
    }
    if (seen[0] >= 2) {
        int of_len_2 = (int) ((long long) seen[0] * (seen[0] - 1) / 2 % MOD);
        add(answer, MOD - of_len_2); // - of len 2
    }

    // cerr << "after cnt even: " << answer << endl;

    for (int x = 0; x < 2; x++) {
        for (int y = 0; y < 2; y++) {
            add(answer, dp[n][x][y]);
            // cerr << "add " << x << ", " << y << " = " << dp[n][x][y] << endl;
        }
    }

    int of_len_2 = (int) ((long long) n * (n - 1) / 2 % MOD);
    // cerr << "sub " << of_len_2 << " from " << answer << endl;
    add(answer, MOD - of_len_2); // subtract of len = 2;

    cout << answer << endl;
}
