#include "testlib.h"

struct Result {
    int ll = 0, lo = 0, rl = 0, ro = 0;
    int l = 0, r = 0;
};

Result readAndCheckTheAnswer(InStream& in, const std::string& s) {
    const int n = s.size();
    Result ans;
    ans.l = in.readInt(-1, n - 1, "k");
    if (ans.l == -1)
        return ans;
    if (ans.l == 0)
        in.quitf(_wa, "cannot take zero items");
    ans.r = n - ans.l;
    int loafs = 0, onions = 0;
    for (char c : s)
        if (c == 'L')
            ++loafs;
        else
            ++onions;
    for (int i = 0; i < ans.l; ++i)
        if (s[i] == 'L')
            ++ans.ll;
        else
            ++ans.lo;
    ans.rl = loafs - ans.ll;
    ans.ro = onions - ans.lo;
    if (ans.ll == ans.rl)
        in.quitf(_wa, "incorrect answer: in the first %d items there are %d loafs, the same number is in the remaining %d items",
                 ans.l, ans.ll, ans.r);
    if (ans.lo == ans.ro)
        in.quitf(_wa, "incorrect answer: in the first %d items there are %d onions, the same number is in the remaining %d items",
                 ans.l, ans.lo, ans.r);
    return ans;
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    inf.readInt(2, 200, "n");
    std::string s = inf.readToken();
    Result pa = readAndCheckTheAnswer(ouf, s);
    Result ja = readAndCheckTheAnswer(ans, s);
    if (ja.l < 0)
        if (pa.l < 0)
            quitf(_ok, "the participant didn't find the answer neither did the jury: the proper division is impossible");
        else
            quitf(_fail, "the jury didn't find the answer but the participant did: in the first %d items the participant gets LO = (%d, %d), in the remaining %d LO = (%d, %d)",
                  pa.l, pa.ll, pa.lo, pa.r, pa.rl, pa.ro);
    else if (pa.l < 0)
        quitf(_wa, "the participant didn't find the answer but the jury did: in the first %d items the jury gets LO = (%d, %d), in the remaining %d LO = (%d, %d)",
              ja.l, ja.ll, ja.lo, ja.r, ja.rl, ja.ro);
    else
        quitf(_ok, "the participant found the answer: in the first %d items the participant gets LO = (%d, %d), in the remaining %d LO = (%d, %d)",
              pa.l, pa.ll, pa.lo, pa.r, pa.rl, pa.ro);
}
